/*BEGINPROLOGUE***************************************************************/
/*                                                                           */
/* MODULE:mclientn.c                                                         */
/*                                                                           */
/* COPYRIGHT:                                                                */
/* ----------                                                                */
/* Digital Library Version 2 - 5765-C86.                                     */
/* VisualInfo Version 2 Release 3.0 - 5697-250.                              */
/* (C) Copyright IBM Corp., 1994,1997.  All Rights Reserved.                 */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/* DISCLAIMER OF WARRANTIES:                                                 */
/* -------------------------                                                 */
/* Permission is granted to copy and modify this code, and to distribute     */
/* modified versions provided that both the copyright notices and this       */
/* permission notice appear in all copies and modified versions.  THIS       */
/* SAMPLE CODE IS LICENSED IN ITS AS-IS CONDITION.  IBM DISCLAIMS ANY        */
/* LIABILITY OF ANY KIND FOR DAMAGES WHATSOEVER RESULTING FROM THE USE       */
/* OF THIS CODE.                                                             */
/*                                                                           */
/*****************************************************************************/

/* 1. Change lConnected to fLogon           12/31/97                        */
/* 2. Change default case statement to DisplayErrorMessage(ULONG ulErrorNum) */
/*    from prinf(szErrorGen,rc)              01/05/98                        */
/* 3. Add OpenItemattribute()                01/07/98                        */
/* 4. Add WriteAttribute()                   01/08/98                        */
/* 5. Add CloseAttribute()                   01/09/98                        */
/* 6. Add ReadAttrtibute()                   01/09/98                        */
/* 7. Add UpdateMAttributes()                01/09/98                        */
/* 8. Modified WriteItemName() to have two Item_IDs (non_Media & Media) 01/11*/
/* 9. Modified ReadItemName() to read two Item_IDs      01/11/98             */

//#ifdef _Windows
// #include <windows.h>
//#else
// #if defined AIX  ||  defined FRN_WINNT
//   #include <frnptype.h>
// #else
//    #include <os2.h>                 /*    Main OS/2 header files         */
// #endif
//#endif

#ifdef FRN_WINNT
 #include <windows.h>
#else
 #if defined FRN_AIX  ||  defined AIX
   #include <frnptype.h>
 #endif
#endif




/*****************************************************************************/
/*  Header Files                                                             */
/*****************************************************************************/
//#ifdef FRN_WINNT
//      #include <windows.h>
//      #include <winbase.h>
//#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#ifdef FRN_WINNT
#include <conio.h>
#endif
#include <io.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "errno.h"
#define  FRN_INCL_FI                   /* Include frnpfi.h & frnpfi2.h      */
#define  FRN_INCL_FO                   /* Include frnpfo.h                  */
#include "frnp.h"                      /* Global types                      */
#include "frnpcapi.h"                  /* Structures and constants          */
#include "mclient.h"                   /* Application header file           */




#define  ERR_BADPARMS          1
#define  ERR_BADCMD            2
#define  ERR_NOTCONNECTED      3
#define  ERR_ISOERROR          4
#define  ERR_VALIDATE          5
#define  ERR_NO_USE            6
#define  ERR_FILE_NOT_FOUND    7
#define  ERR_OUTOFRANGE        8
#define  CMD_QUIT              99
#define  BLANK                 ' '
#define  FALSE                             0
#define  TRUE                  1
#define  RC_OK                             0
#define  outputFlag            1
#define  MEDIASTREAMERTITLE    2
#define  VIDEOCHARGERTITLE     33

HSESSION hSession;                     /* Folder Manager session handle     */
OBJ      Obj;                          /* Object data structure             */
HOBJACC  ObjectAccessHandle;           /* Handle of object to be replaced   */
BOOL     fCommit;                      /* Update commit flag                */
BOOL     fVideoChargerObject = TRUE;   /* Check for location of object      */
BOOL     fIsMediaObject      = TRUE;   /* Check for Media or none Media Obj */
CHAR     pszDataBase[RS_LABEL_LENGTH]={""};/*library server                 */
CHAR     pszCommandOption[RS_CUSTOMERID_LENGTH]; /*RS_CUSTOMERID_LENGTH=10  */
CHAR     achFrnrootPath [RS_DIRNAME_LENGTH];  /*120, Path of Frnroot        */
CHAR     DocItemID[RS_ITEM_ID_SIZE];/*17, Item ID of object to be replaced  */
CHAR     MediaIndexID[RS_ITEM_ID_SIZE];/* Item ID of Media object           */
CHAR     achAutoPlayOption[20];        /* Check for play option             */
CHAR     achStartIBMVideoCharger[1024];/* The path of video charger         */
INT      Size = 0;                     /* 0, Maximum Size of Mate file      */
ULONG    ulNoneMediaObjectSize  = 0;   /* file size of none media object    */
BOOL     fLogon = FALSE;               /* true if logon                     */
LONG     Count = 0;                    /* position of current item id       */
ULONG    ulretcode;                    /* return code                       */
ULONG    ulMemoryBlock;                /* Generic pointer for SimLibFree    */
ULONG    ulTotalNumItemId;             /* Total number of Item ID           */
BOOL     fMediaObject= 1;              /* Check for Media or non media obj  */
INT      iObjectState;                 /* Media Object State                */
BOOL     fNotperfetch;                 /* Check for retrieve Action code    */
HITEM    hItem;                        /* Virtual Item                      */

/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : main                                                 */
/*                                                                          */
/*  Description      : main() function of a sample application that uses    */
/*                     Folder Manager APIs to store an object, retrieve an  */
/*                     existing object, and delete an existing object.      */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions:                                   */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  VOID.                                               */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  void main ( void ).                                 */
/*                                                                          */
/*  Return values    :  If all functions are successful, the return code    */
/*                      from CmdQuit() is returned.  Otherwise, the return  */
/*                      code from CmdConnect(),CmdMStore(), CmdMRetrieve(), */
/*                      or CmdMDiscard()is returned.                        */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Establish a session with the Folder Manager.                    */
/*      2.  If logon was successful:                                        */
/*          - Free the USERLOGONINFOSTRUC memory and                        */
/*                              - Store a media Object                                      */
/*                              - Retrieve an existing media object                         */
/*                 - If the object is successfully opened,                  */
/*                 - Query media object index attributes                    */
/*                 - Read meta file and store to view.tmp                   */
/*                 - Close the object.                                      */
/*              - Discard and existing media object                         */
/*              - Close the object.                                         */
/*          Logoff from the Folder Manager session.                         */
/*      3.  Exit main() with a return code.                                 */
/*                                                                          */
/*  Notes            : None.                                                */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

VOID main(VOID)
{
    time_t ltime;
    LONG rc  = 0;                              /* return code               */
    CHAR szCommandStr[1024];

//      strcpy(achFrnrootPath, getenv("FRNROOT"));/* getting the path of FRNROOT*/



        /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
        /* This program assume that mclient.in load.txt, mclient.ctl            */
        /* and document.lst     are in the same directory                           */
    /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
        strcpy(achFrnrootPath,".");
        if (achFrnrootPath == NULL )   /* If FRNROOT is not define, exit program*/
        {
                printf("An Error occured during getting Frnroot Path from the system \n");
                fflush (stdout);
                exit(1);
        }


        GetCtlFileInfo();    /* getting control file information                */
    srand(time(0));      /* set srand here and only once, to avoid repeats  */
    time(&ltime);        /* getting current time                            */
    ItemIdFileInfo( );   /* Getting ItemID File Information                 */

    DisplayCommands();   /* This is the main command processing loop.       */

    while (rc != CMD_QUIT)
    {

                printf(szPrompt);
        fflush(stdout);
                fflush(stdin);

        if (gets(szCommandStr) == NULL)       /* Getting command from user  */
            rc = CmdQuit("");                 /* EOF or read error. Quit!   */
        else
            rc = CmdExecute(szCommandStr,     /* Searching for a valid      */
                                CmdTable);    /* command from CmdTable      */

        switch (rc)
        {
        case  ERR_BADPARMS :                  /* bad parameter              */
                        printf(szErrorParam);
            DisplayCommands();
            break;
        case  ERR_BADCMD :                    /* bad command                */
             printf(szErrorCmd);
             DisplayCommands();
             break;
        case  ERR_NOTCONNECTED :              /* user is not logon          */
             printf(szErrorNotCon);
             break;
        case  ERR_VALIDATE :                              /* object is invalid          */
             printf(szErrorValidate);
             break;
        case  CMD_QUIT :                      /* quiting. Not an error!     */
             break;
        case  ERR_FILE_NOT_FOUND :                        /* File NOT FOUND             */
             printf(szErrorFile);
             break;
        case  ERR_OUTOFRANGE:                 /* paramter is out of range of*/
                         printf(szErrorOutOfRange);       /* document.lst               */
                         break;
        case  RC_OK :                                             /* This one is ok.            */
             break;
        default  :  // jl, 2
                         DisplayErrorMessage(rc);         /* Show the FRN Error Message */
        }
    }                                         /* end of while               */

    time(&ltime);
}


/*--------------------------------------------------------------------------*/
/* void CmdExecute(void) - execute a command                                */
/*--------------------------------------------------------------------------*/

static INT CmdExecute(CHAR *cmd,COMMAND CmdTable0[])

{
    INT i,j,rc,len,maxcmd;
    CHAR *p;

    /************************************************************************/
    /* Skip leading blanks on the command line                              */
    /************************************************************************/

    while (*cmd == BLANK)
        ++cmd;

    /************************************************************************/
    /* Check there really is a command to execute                           */
    /************************************************************************/

    if (*cmd == '\0')
        return  ERR_BADCMD;

    /************************************************************************/
    /* Search the table looking for the command. The 'strcmp' function can't*/
    /* be used since the command may have been typed in upper or lower case */
    /* (or a mix). 'stricmp' is not an ANSI C defined function.             */
    /************************************************************************/

    maxcmd = sizeof(CmdTable)/sizeof(COMMAND);
    rc = ERR_BADCMD;
    for (i = 0; i < maxcmd; i++)
    {
        p = CmdTable0[i].name;
        len = strlen(p);


        for (j = 0; j < len && cmd[j] != '\0'; j++)
            if (toupper(cmd[j]) != p[j])
                break;

            /****************************************************************/
            /* If we find a match, skip to the parameters for the command   */
            /* and call the command routine. A special check is made for    */
            /* commands that require a blank, but have no parameters (so the*/
            /* blank is not required).                                      */
            /****************************************************************/

        if (j == len || (j == len-1 && p[j] == BLANK && cmd[j] == '\0'))
        {
            cmd += j;
            while (*cmd == BLANK)
                ++cmd;

            rc = (*(CmdTable0[i].function))(cmd);
            break;
        }
    }
    return  rc;
}



/*--------------------------------------------------------------------------*/
/* static int CmdConnect(char* parm)  - Logon to Library Server             */
/*--------------------------------------------------------------------------*/

static INT CmdConnect(CHAR *parm)
{

        ulretcode = 0;                       /* initialize return code to 0     */

    if (*parm == '\0')                   /* If No database name provided,   */
        {
        return  ERR_BADPARMS;            /* Return to caller                */
    }

        if (fLogon)                          /* If user is already logon,       */
        {
                ulretcode = Logoff();            /* Logoff current user             */
        }

        if (ulretcode)                       /* If Logoff Error, display message*/
        {
                printf("Logoff error %s with return code = %lu\n",pszDataBase, ulretcode);
                fflush(stdout);
        }

    /*************************************************************************/
    /*  Call Logon to establish a Folder Manager Session.                    */
    /*************************************************************************/

        ulretcode = Logon(parm);             /* Logon to library server          */

    /*************************************************************************/
    /* If successful, call FreeMemory to free the memory for structure       */
    /* USERLOGONINFOSTRUC returned from SimLibLogon.                         */
    /*************************************************************************/
    if (ulretcode == SIM_RC_OK)
        {
        FreeMemory();
        }
        else
        {
                return (INT) ulretcode;
        }

        return RC_OK;
}


/*--------------------------------------------------------------------------*/
/* static int CmdStore(char* parm)       - Store a nonMedia Object          */
/*--------------------------------------------------------------------------*/
static INT CmdStore(CHAR *parm)
{

        if (!fLogon)
        {
                return ERR_NOTCONNECTED;
        }

    fMediaObject = FALSE;

        /*************************************************************************/
    /*  Call CreateDocumentItemID to create a new document ItemID.           */
    /*************************************************************************/

    ulretcode = CreateDocumentItemID();

    /*************************************************************************/
    /* If successful, call FreeMemory to free the memory containing the      */
    /* document ItemID.                                                      */
    /*************************************************************************/


        if (ulretcode == SIM_RC_OK)
    {
                FreeMemory();

    /*************************************************************************/
    /*  Call StoreObject to create a new object using an existing file.      */
    /*  The new object will be stored as part of the newly created document. */
    /*************************************************************************/

        ulretcode = LoadObject(parm);
            if (ulretcode)
                {
                        printf("Error in LoadObject %lu \n",ulretcode);
                        fflush(stdout);
                        return (INT) ulretcode;
                }

    /*************************************************************************/
    /* If successful, call FreeMemory to free the memory containing the      */
    /* object handle.                                                        */
    /*************************************************************************/

                if (ulretcode == SIM_RC_OK)
        {
            FreeMemory();
                }
        }

    return RC_OK;
}


/*--------------------------------------------------------------------------*/
/* static int CmdMStore(char* parm)     - Store a Media Object              */
/*--------------------------------------------------------------------------*/
static INT CmdMStore(CHAR *parm)
{

        if (!fLogon)
        {
                return ERR_NOTCONNECTED;
        }

    fMediaObject = TRUE;
    /*************************************************************************/
    /*  Call CreateContentClasses to create new content classes.             */
    /*************************************************************************/
        ulretcode = LoadMediaObject(NULL);
        if (ulretcode)
        {
                printf("Error in LoadMediaObject %lu \n",ulretcode);
                fflush(stdout);
                return (INT)ulretcode;
        }

    return RC_OK;
}





/*--------------------------------------------------------------------------*/
/* static int CmdMMigration(char* parm)     - Store a Media Object          */
/*--------------------------------------------------------------------------*/
static INT CmdMMigration(CHAR *parm)
{


        if (!fLogon)                        /* If the user is not logon         */
        {
                return ERR_NOTCONNECTED;        /* Return to caller                 */
        }

    if (*parm == '\0')                  /* If No file name provided,        */
        {
        return  ERR_BADPARMS;           /* Return to caller                 */
    }

    fMediaObject = TRUE;                /* Indicate this is a media object  */

        /*************************************************************************/
    /* Call MediaMigration funtion to migrate Video Charger Objects          */
    /* Digital Library Video Charger Objects                                 */
    /*************************************************************************/
        ulretcode = MediaMigration(parm);

    return (INT) ulretcode;
}




/*--------------------------------------------------------------------------*/
/* static int CmdMQuery(char* parm)                                         */
/*--------------------------------------------------------------------------*/
static INT CmdMQuery(CHAR *parm)
{

        if (!fLogon)
                return ERR_NOTCONNECTED;


    if (*parm == '\0')
        {
        return  ERR_BADPARMS;
    }

        Count = atoi(parm);

        if ((ULONG)Count > ulTotalNumItemId || Count < 1)
        {
                return ERR_OUTOFRANGE;
        }
    fMediaObject = TRUE;
        /*************************************************************************/
    /* Get Doucment ID from file index                                       */
    /*************************************************************************/
    ReadItemName(Count);


        /*************************************************************************/
    /* Call QueryMediaIndexAttr to                                           */
    /* query the idex class ID and attribute IDs of the FRN$MEDIA index class*/
    /*************************************************************************/
        ulretcode = QueryMediaIndexAttr();
        if (ulretcode)
        {
                printf("Error in QueryMediaIndexAttr()  %lu\n", ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }

        return RC_OK;
}


/*--------------------------------------------------------------------------*/
/* static int CmdQuery(char* parm)                                          */
/*--------------------------------------------------------------------------*/
static INT CmdQuery(CHAR *parm)
{

        if (!fLogon)
                return ERR_NOTCONNECTED;


    if (*parm == '\0')
        {
        return  ERR_BADPARMS;
    }

        Count = atoi(parm);
    fMediaObject = FALSE;

        /*************************************************************************/
    /* Get Doucment ID from file index                                       */
    /*************************************************************************/
    ReadItemName(Count);

        /*************************************************************************/
    /* Call QueryObject to                                                   */
    /* query Object attributes                                               */
    /*************************************************************************/
        ulretcode = QueryObject();
        if (ulretcode)
        {
                printf("Error in QueryObject()  %lu\n", ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }

        return RC_OK;
}


/*--------------------------------------------------------------------------*/
/* static int CmdMRetrieve(char* parm)                                      */
/*--------------------------------------------------------------------------*/
static INT CmdMRetrieve(CHAR *parm)
{

        if (!fLogon)
                return ERR_NOTCONNECTED;

    if (*parm == '\0')
        {
        return  ERR_BADPARMS;
    }

        Count = atoi(parm);
        if ((ULONG)Count > ulTotalNumItemId || Count < 1)
        {
                return ERR_OUTOFRANGE;
        }

        fMediaObject  = TRUE;
    fVideoChargerObject = TRUE;

        /*************************************************************************/
    /* Get Doucment ID from file index                                       */
    /*************************************************************************/
    ReadItemName(Count);

        /*************************************************************************/
    /* Call OpenObject to                                                    */
    /* open a previously created object.                                     */
    /*************************************************************************/
        ulretcode = OpenObject();
        if (ulretcode)
        {
                printf("Error in OpenObject()  %lu\n", ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }


        /*************************************************************************/
    /* Call ReadObject to                                                    */
    /* transfer the number of bytes you specify from an object into the data */
        /*  buffer.                                                                                                                          */
    /*************************************************************************/
        ulretcode = ReadObject();
        if (ulretcode)
        {
                printf("Error in ReadObject()   %lu\n", ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }
        /*************************************************************************/
    /* Call CloseObject to                                                   */
    /* Close an open object and end access to that object.                   */
    /*************************************************************************/
        ulretcode = CloseObject();
        if (ulretcode)
        {
                printf("Error in CloseObject()  %lu\n", ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }
    return RC_OK;
}



/*--------------------------------------------------------------------------*/
/* static int CmdRetrive(char* parm)                                        */
/*--------------------------------------------------------------------------*/

static INT CmdRetrieve(CHAR *parm)
{

        CmdQuery(parm);
        if (!fLogon)
                return ERR_NOTCONNECTED;

    if (*parm == '\0')
        {
        return  ERR_BADPARMS;
    }

        Count = atoi(parm);
    fMediaObject = FALSE;

        /*************************************************************************/
    /* Get Doucment ID from file index                                       */
    /*************************************************************************/
    ReadItemName(Count);

        /*************************************************************************/
    /* Call OpenObject to                                                    */
    /* open a previously created object.                                     */
    /*************************************************************************/
        ulretcode = OpenObject();
        if (ulretcode)
        {
                printf("Error in OpenObject()  %lu\n", ulretcode);
                fflush(stdout);
        }

        /*************************************************************************/
    /* Call ReadObject to                                                    */
    /* transfer the number of bytes you specify from an object into the data */
        /*  buffer.                                                                                                                          */
    /*************************************************************************/
        ulretcode = ReadObject();
        if (ulretcode)
        {
                printf("Error in ReadObject()   %lu\n", ulretcode);
                fflush(stdout);
        }

        /*************************************************************************/
    /* Call CloseObject to                                                   */
    /* Close an open object and end access to that object.                   */
    /*************************************************************************/
        ulretcode = CloseObject();
        if (ulretcode)
        {
                printf("Error in CloseObject()  %lu\n", ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }
    return RC_OK;
}


/*---------------------------------------------------------------------------*/
/* static int CmdMDiscard(char* parm)                                        */
/*---------------------------------------------------------------------------*/

static INT CmdMDiscard(CHAR *parm)
{

        if (!fLogon)
        {
                return ERR_NOTCONNECTED;
        }

    if (*parm == '\0')
        {
        return  ERR_BADPARMS;
    }
    fMediaObject = TRUE;
        /*************************************************************************/
    /* Call DeleteMediaObject to                                             */
    /* Delete a previously created object.                                   */
    /*************************************************************************/
        ulretcode = DeleteMediaObject (parm);
        if (ulretcode)
        {
                printf("Error in DeleteMediaObject  %lu\n",ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }

        ulTotalNumItemId --;
    return RC_OK;
}

/*---------------------------------------------------------------------------*/
/* static int CmdDiscard(char* parm)                                         */
/*---------------------------------------------------------------------------*/
static INT CmdDiscard(CHAR *parm)
{

        if (!fLogon)
        {
                return ERR_NOTCONNECTED;
        }

    if (*parm == '\0')
        {
        return  ERR_BADPARMS;
    }

    fMediaObject = FALSE;
        /*************************************************************************/
    /* Call DeleteMediaObject to                                             */
    /* Delete a previously created object.                                   */
    /*************************************************************************/
        ulretcode = DeleteMediaObject (parm);
        if (ulretcode)
        {
                printf("Error in DeleteMediaObject  %lu\n",ulretcode);
                fflush(stdout);
                return (INT) ulretcode;
        }
        ulTotalNumItemId --;
    return RC_OK;
}


/*--------------------------------------------------------------------------*/
/* static int CmdHelp(char* parm)                                           */
/*--------------------------------------------------------------------------*/
static INT CmdHelp(CHAR *parm)
{
        printf("Description:    This is a sample application that uses Folder Manager APIs to :\n");
        printf("\n\n");
        printf(">>C [library server name]    logon to library server (mclient.in)\n");
//      printf(">>S  [File Name]             store a new object (local file name)\n");
//      printf(">>NQ [Index #]               query an existing object <document.lst)\n");
//      printf(">>R  [Index #]               retrieve the content file of an existing object(document.lst).\n");
//      printf(">>D  [Index #]               delete an existing object(document.lst).\n");
        printf(">>MS                         store a new media object (mclient.in & load.txt)\n");
        printf(">>MQ [Index #]               query an existing media object (document.lst)\n");
        printf(">>MR [Index #]               retrieve the meta file of an existing object(document.lst).\n");
        printf(">>MD [Index #]               delete an existing media object(document.lst).\n");
        printf(">>MG [File Name]             migration of Video Charger to Digital Library Video Charger.\n");
        printf(">>MA [Index #]               update Media attributes in the previouly stored object.\n");
        printf(">>Q                          exit program.\n\n");
        fflush(stdout);
        return RC_OK;
}

/*--------------------------------------------------------------------------*/
/* static int CmdQuit(char* parm)                                           */
/*--------------------------------------------------------------------------*/

static INT CmdQuit(CHAR *parm)
{
    time_t ltime;

    /************************************************************************/
    /* Check If user include a parameter                                    */
    /************************************************************************/
    if (*parm != '\0')
        {
        return  ERR_BADPARMS;
    }

    time(&ltime);

    printf(szRespQuit,
           ctime(&ltime));
        fflush(stdout);

    /************************************************************************/
    /* Check if user still logon to the library server                      */
    /************************************************************************/
        if (fLogon)
        {
                ulretcode = Logoff();
        }
    return  CMD_QUIT;

}



/*---------------------------------------------------------------------------*/
/* void displayCommands(void)                                                */
/*---------------------------------------------------------------------------*/

VOID DisplayCommands(VOID)
{
        printf(szUsing,
           pszDataBase);
    printf(szCommand);
    printf("\n\t%s",
           szHelp);
    printf("\n\t%s",
           szUse);
    printf("\n\t%s",
           szMStore);
        printf("\n\t%s",
                   szMQuery);
    printf("\n\t%s",
           szMRetrieve);
    printf("\n\t%s",
           szMDiscard);
    printf("\n\t%s",
           szMMigrate);
    printf("\n\t%s",
           szMUpdateAttributes);

//    printf("\n\t%s",
//           szStore);
//        printf("\n\t%s",
//                 szQuery);
//    printf("\n\t%s",
//           szRetrieve);
//    printf("\n\t%s",
//           szDiscard);
    printf("\n\t%s",
           szQuit);
        fflush(stdout);
}



/*---------------------------------------------------------------------------*/
/* int GetCtlFileInfo(void)                                                  */
/*---------------------------------------------------------------------------*/

INT GetCtlFileInfo()
{
    FILE * stream;
    CHAR  buffer[100];
    CHAR  achtemp1[100];
    CHAR  achtemp2[100];
    CHAR  achtemp3[100];

    /*************************************************************************/
    /* Read from input file for control parameters                           */
    /*************************************************************************/
        sprintf(buffer,"%s/mclientn.ctl", achFrnrootPath);
    stream = fopen(buffer, "r");

        printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
        fflush(stdout);


    if (stream == NULL)
    {
                printf("Can Not open file:  %s \n",buffer);
                printf("using default setting: \n");
        printf("This program will no play the video when you using <mr> command \n\n\n\n");
            fflush(stdout);
    }
    else
    {
        fscanf(stream, "%s %s %s %s",achtemp1,achtemp2,achtemp3, achAutoPlayOption);
        strcat(achStartIBMVideoCharger, achtemp1);
                strcat(achStartIBMVideoCharger, " ");
        strcat(achStartIBMVideoCharger, achtemp2);
                strcat(achStartIBMVideoCharger, " ");
        strcat(achStartIBMVideoCharger, achtemp3);
        printf("You selected following setting:\n");
        printf("%s ",achStartIBMVideoCharger);
        printf("  ======> %s\n",achAutoPlayOption);
        fflush(stdout);
        fclose(stream);
    }

    return RC_OK;
}



/*--------------------------------------------------------------------------*/
/* void DumpRc(PRCSTRUCT pRC) - Display Return Code                         */
/*--------------------------------------------------------------------------*/
VOID DumpRC (PRCSTRUCT pRC)
{
        printf ("\n...........................................\n");
    printf ("**** RCSTRUCT ****\n");
    printf ("pRC->ulStruct : %ld\n", pRC->ulStruct);
    printf ("pRC->ulRC : %ld\n", pRC->ulRC);
    printf ("pRC->usParam : %d\n", pRC->usParam);
    printf ("pRC->ulParam1 : %ld\n", pRC->ulParam1);
    printf ("pRC->ulParam2 : %ld\n", pRC->ulParam2);
    printf ("pRC->ulExtRC: %ld\n", pRC->ulExtRC);
    printf ("pRC->ulExtReason: %ld\n", pRC->ulExtReason);
    printf ("pRC->:hErrLog: %lu\n\n", pRC->hErrLog);
        printf ("...........................................\n");
        fflush(stdout);
}






/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : ReadItemName                                         */
/*                                                                          */
/*  Description      : This function is called from command function to     */
/*                     read item name from indexID file                     */
/*                                                                          */
/*  Dependencies     : Global Variables :  DocItemID                        */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  VOID.                                               */
/*                                                                          */
/*  Input Parameters :  count.                                              */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  VOID ReadItemName(INT count)                        */
/*                                                                          */
/*  Return values    :                                                      */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Open document.lst for read                                      */
/*      2.  copy one entry from document.lst to a global variable DocItemID */
/*      3.  Return to Calller                                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/
VOID ReadItemName(INT count)
{
    FILE* FileHandle;            /* File Handle for document.lst            */
    INT   rc;                    /* Return Code                             */
    CHAR  achFileName[100];              /* Store complete path of file name        */
        PSZ   pszLine;               /* Pointer to a line on Document.list      */
    CHAR  achBuffer[100];          /* Temp storage                            */
    CHAR  seps[] = " \t\n";      /* Delimiter                               */
        PSZ   pszToken;
        INT   i;




    if (count < 1)               /* Check if document.lst contains no entry */
    {
        printf("error in index value\n");
                fflush(stdout);
                exit(1);
    }


        if (fMediaObject)
        {
                sprintf(achFileName,"%s/document.lst", achFrnrootPath);
        }
        else
        {
                sprintf(achFileName,"%s/DocId.lst", achFrnrootPath);
        }
    FileHandle = fopen(achFileName, "r");

        if (FileHandle == NULL)
        {
                printf("Error cannot open file for Read : %s \n", achFileName);
                printf("EXIT PROGRAM  !!! \n");
                fflush(stdout);
                exit(1);
        }
        else
        {
            ++count;

                for (i=0; i<count; i++)  /* Skip Header      */
                {
                        pszLine = fgets(achBuffer, 100, FileHandle);
                }

                if  ( fgets(achBuffer, 100, FileHandle) != NULL)
                {
                        pszToken = strtok (achBuffer, seps);
                        pszToken = strtok (NULL, seps);
                        strcpy (DocItemID,pszToken);
                        pszToken = strtok ( NULL, seps);
                        strcpy(MediaIndexID,pszToken);
                        fflush(stdout);
                }
                else
                {
                        printf("fget failed\nEXIT program");
                        exit(1);
                }
        }

    DocItemID[16] = 0;
    rc = fclose(FileHandle);

    return ;
}


/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : DeleteItemName                                       */
/*                                                                          */
/*  Description      : This function is called from commmand funtions to    */
/*                     delete a index from ItemID file                      */
/*                                                                          */
/*  Dependencies     : Global Variables :  DocItemID                        */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  VOID.                                               */
/*                                                                          */
/*  Input Parameters :  count.                                              */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  VOID DeleteItemName(INT count)                      */
/*                                                                          */
/*  Return values    :  none                                                */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Open document.lst for read                                      */
/*      2.  delete an index ID for the Document.lst                         */
/*      3.  Return to Calller                                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

VOID DeleteItemName(INT count)
{
    FILE *FileHandleLst;                /* File Handle for document.lst     */
    FILE *FileHandleTmp;                /* File Handle for document.tmp     */
    INT rc;
    INT i;
    CHAR *record;
    CHAR buffer[100];
        CHAR docfilepath [100];
        CHAR tempfilepath [100];
    CHAR  seps[] = " \t\n";      /* Delimiter                               */
    PSZ   pszToken;
        CHAR  achNonMediaItemID[17];
    CHAR  achMediaItemID[17];
    if (count < 1)               /* If Index number is than 1, quit program */
    {
        printf("error in index value\n");
        exit(1);
    }

        if( fMediaObject)                       /* If deleting a media object,  */
        {
                sprintf(docfilepath,"%s/document.lst", achFrnrootPath);
        }
        else                                    /* If deleting a nonmedia object*/
        {
                sprintf(docfilepath,"%s/DocID.lst", achFrnrootPath);
        }

    FileHandleLst = fopen(docfilepath, "r");/* Open document file for read  */
    if (FileHandleLst == NULL)
        {
                printf("Open <%s> error in DeleteItemName!!!\n,Exit program\n",docfilepath);
                exit(1);
        }


        sprintf(tempfilepath,"%s/document.tmp", achFrnrootPath);
    FileHandleTmp = fopen(tempfilepath, "w");/* Create a temp file for write*/
    if (FileHandleTmp == NULL)
        {
                printf("Open <%s> error in DeleteItemName!!!\n,Exit program\n",tempfilepath);
                exit(1);
        }

        count ++;
    for(i=0;i<count;i++)
    {
        record = fgets(buffer, 100, FileHandleLst);
        rc = fputs(buffer,FileHandleTmp);
    }

    record = fgets(buffer, 100, FileHandleLst);  /* delete an entry         */

        count -= 2;

    while(record)
    {
        record = fgets(buffer, 100, FileHandleLst);
                rc = feof(FileHandleLst);
        if(rc)
                {
           break;
                }

                pszToken = strtok (buffer, seps);
                pszToken = strtok (NULL, seps);
                strcpy (achNonMediaItemID,pszToken);
                pszToken = strtok ( NULL, seps);
                strcpy(achMediaItemID,pszToken);

                count ++;
                fprintf(FileHandleTmp,"%7d     %s     %s\n",count,achNonMediaItemID,achMediaItemID);


//        rc = fputs(buffer,FileHandleTmp);
    }


    rc = fclose(FileHandleLst);
    rc = fclose(FileHandleTmp);

    rc = remove(docfilepath);
    rc = rename(tempfilepath,docfilepath);

    return ;
}

/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : WriteItemName                                        */
/*                                                                          */
/*  Description      : This function is called from commmand funtions to    */
/*                     write an entry in ItemID file                        */
/*                                                                          */
/*  Dependencies     : Global Variables : ulTotalNumItemId                  */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  VOID.                                               */
/*                                                                          */
/*  Input Parameters :  name.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  VOID WriteItemName(CHAR name)                       */
/*                                                                          */
/*  Return values    :  none                                                */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Open document.lst for read                                      */
/*      2.  write an index ID to the Document.lst                           */
/*      3.  Return to Calller                                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

VOID WriteItemName(PSZ pszItemID, PSZ pszMediaItemID)
{
        FILE    *FileHandle;                    /* File Handle for document.lst */
        INT rc;
        CHAR buffer[100];

        if (fMediaObject)
        {
                sprintf(buffer,"%s/document.lst", achFrnrootPath);
        }
        else
        {
                sprintf(buffer,"%s/DocId.lst", achFrnrootPath);
        }

        FileHandle = fopen(buffer, "r");
        if (FileHandle == NULL)
        {
                FileHandle = fopen(buffer,"w");
                if (FileHandle == NULL)
                {
                        printf("Can Not open file:  %s in WriteItemName\n",buffer);
                        exit(1);
                }
                else
                {
                        fprintf(FileHandle,"INDEX#:     ITEM_ID              MEDIA_ITEM_ID        TIME_STAMP\n");
                        fprintf(FileHandle,"-------     ----------------     ----------------     --------------------\n");
                        fclose(FileHandle);
                }
        }
        else
        {
                fclose(FileHandle);
        }

        FileHandle = fopen(buffer, "a+");

        // If Open File error, quit program
        if (FileHandle == NULL)
        {
                printf("Can Not open file:  %s in WriteItemName\n",buffer);
                exit(1);
        }
        else
        {
                ulTotalNumItemId ++;
                fprintf(FileHandle,"%7d     %s     %s\n",ulTotalNumItemId,pszItemID,pszMediaItemID);
                fclose(FileHandle);
        }


    printf("Item ID: is stored :::>>>  %lu  in %s file\n",ulTotalNumItemId,buffer);
        fflush(stdout);
    rc = fclose(FileHandle);

    return;
}


/*--------------------------------------------------------------------------*/
/* void ItemIdFileInfo( void ) - Display Item ID File Info.                 */
/*--------------------------------------------------------------------------*/
void ItemIdFileInfo( void )
{

#ifdef FRN_WINNT
    struct _stat buf;
#endif

    INT   result;
    CHAR  DocIdfileName[100];
        CHAR  achItemID[256];
        FILE* FileHandle;
    INT   iCount = 0;
        INT   rc;

    sprintf(DocIdfileName,"%s/document.lst", achFrnrootPath);

    FileHandle = fopen(DocIdfileName, "r");
    if (FileHandle != NULL)
        {
                for (iCount =1; iCount<3; iCount++)
                {
                        fgets(achItemID,100,FileHandle);
                }

                iCount = 0;                       /* reset counter to count number of IndexID */

                while ( fgets(achItemID,100,FileHandle) != NULL)
                {
                        iCount++;
                }
            rc = fclose(FileHandle);
        }

        ulTotalNumItemId = iCount;
    printf( "Document.lst contains < %d > ITEMIDs\n",ulTotalNumItemId);

#ifdef FRN_WINNT

        result = _stat( DocIdfileName, &buf );/* Get data associated with "stat.c": */

        if( result == 0 )                     /* Check if statistics are valid:     */
                {
                                                      /* Output some of the statistics:     */
                   printf( "Last modified : %s", ctime( &buf.st_atime ) );
                }
#endif
            fflush(stdout);
}




/*--------------------------------------------------------------------------*/
/* static INT CmdUpdateMAttributes(CHAR* pszItemIndexNum) update Media Atts */
/*--------------------------------------------------------------------------*/
static INT CmdUpdateMAttributes(CHAR* pszItemIndexNum)
{
    RCSTRUCT        RCStruct;               /* RC data structure                */
    ULONG           ulRC;               /* Return Code                      */
        USHORT          usMediaClassID;     /* FRN$MEDIA class ID               */
        USHORT          pusMediaAttrID[19]; /* FRN$MEDIA attributes, array of 19*/


        if (!fLogon)
                return ERR_NOTCONNECTED;


    if (*pszItemIndexNum == '\0')
        {
        return  ERR_BADPARMS;
    }

    fMediaObject = TRUE;

        /*************************************************************************/
    /* Get Doucment ID from file index                                       */
    /*************************************************************************/
        Count = atoi(pszItemIndexNum);


        if ((ULONG)Count > ulTotalNumItemId || Count < 1)
        {
                return ERR_OUTOFRANGE;
        }

        /*************************************************************************/
    /* Get Doucment ID from file index                                       */
    /*************************************************************************/
    ReadItemName(Count);

        /*************************************************************************/
    /* Get MediaClassID and MediaAttrID from Library Server                  */
    /*************************************************************************/
        ulRC = SimLibQueryMediaIndexAttr(hSession,  /* Folder Manager session handle     */
                            &usMediaClassID,                /* FRN$MEDIA class ID                */
                                pusMediaAttrID,                 /* FRN$MEDIA attributes, array of 19 */
                                NULL,                           /* Object handle for the Media Object*/
                                (PRCSTRUCT)&RCStruct);          /* Pointer to RC data structure      */


        if (RCStruct.ulRC == SIM_RC_OK && ulRC == SIM_RC_OK)
        {
                /*************************************************************************/
                /* Open Item Attribute Session to Get virtual item Handle                */
                /*************************************************************************/
                ulRC = OpenItemAttribute(usMediaClassID);
                if (ulRC == SIM_RC_OK)
                {
                        /*************************************************************************/
                        /* Update Item Attribute                                                 */
                        /*************************************************************************/
                        ulRC = WriteAttribute(pusMediaAttrID);
                        if (ulRC != SIM_RC_OK)
                        {
                                return (INT)ulRC;
                        }

                        /*************************************************************************/
                        /* Close Item Attribute Session                                          */
                        /*************************************************************************/
                        ulRC = CloseAttribute();
                        printf("Meida Attributes been updated.\n");
                }
                else
                {
                        CloseAttribute();
                        return (INT) ulRC;
                }
        }
        else
        {
                printf("SimLibQueryMediaIndexAttr error %lu\n", ulRC);
                DumpRC(&RCStruct);
        }

        return (INT) RCStruct.ulRC;

}




INT DisplayErrorMessage(ULONG ulErrorNum)
{
    FILE* stream;                 /* File pointer                                */
        char* line;                   /* Pointer to a line of FRNPERR.H              */
        char* token;                              /* Prase string into tokens                    */
        char* pchErrorMessage;        /* Error Message that need to display          */
    char  buffer[100];            /* Temp storage                                */
    char  szSeps[] = " ,\t\n";    /* Delimiter                                   */
        char  szErrorCode[10];        /* Input Error Code                            */
        char  szErrorFile [100];      /* Full path of ERROR FILE (FRNPERR.H)         */
        BOOL  fDone = FALSE;          /* Check of if Error Code matchs one of entry. */

        /* Getting Full path of FRNPERR.H  */
    //  sprintf(szErrorFile, "%sinclude\\frnperr.h",achFrnrootPath);

        sprintf(szErrorFile, "%s/include/frnperr.h",getenv("FRNROOT"));
        stream = fopen(szErrorFile, "r");

        /* If Open File error, quit program  */
        if (stream == NULL)
        {
                printf("Can Not open file:  %s\n",szErrorFile);
                fflush(stdout);
                exit(1);
        }
        else
        {
                /* Convert integer to character array   */
                sprintf(szErrorCode, "%d", ulErrorNum);

                /* Read one line at a time, If Error Code matchs, then display error message.*/
                while(!fDone && (line = fgets(buffer, 100, stream)) != NULL)
                {
                        token = strtok (buffer, szSeps);
                        while ( token != NULL )
                        {
                                if (strcmp(token, "#define") == 0  )
                                {
                                        pchErrorMessage = strtok ( NULL, szSeps);
                                        token = strtok (NULL, szSeps);
                                        if( strcmp (szErrorCode, token) == 0)
                                        {
                                                printf("\n\n\n%s =========>  %s \n\n\n",szErrorCode, pchErrorMessage);
                                                fDone = TRUE;
                                                fflush(stdout);
                                        }
                                }
                                else
                                {
                                        token = NULL;
                                }
                        }

                }

                // If not match the Error code, display not found message.
                if (!fDone)
                {
                        printf("ERROR CODE <%s> is not in %s\n",szErrorCode, szErrorFile);
                        fflush(stdout);
                }
                fclose(stream);
        }

    return RC_OK;

}




/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : CmdListItemID                                        */
/*                                                                          */
/*  Description      : This function is called from main funtions to list   */
/*                     all the Index ID from a file                         */
/*                                                                          */
/*  Dependencies     : Global Variables : ulTotalNumItemId                  */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  VOID.                                               */
/*                                                                          */
/*  Input Parameters :  name.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  VOID CmdListItemID(CHAR* parm)                      */
/*                                                                          */
/*  Return values    :  none                                                */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Open document.lst for read                                      */
/*      2.  read all the index IDs from the Document.lst                    */
/*      3.  Return to Calller                                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

static INT CmdListItemID(CHAR* parm)
{


        FILE*   FileHandle;                    /* File Handle for document.lst */
        INT             rc;
        CHAR    buffer[100];
        INT             iCount = 0;
        CHAR    achItemID[100];

        if (fMediaObject)
        {
                sprintf(buffer,"%s/document.lst", achFrnrootPath);
        }
        else
        {
                sprintf(buffer,"%s/DocId.lst", achFrnrootPath);
        }

    FileHandle = fopen(buffer, "r");
    if (FileHandle == NULL)
        {
                printf("There is no INDEX ID in %s\n",buffer);
                fflush(stdout);
        }
        else
        {
                if (ulTotalNumItemId != 0)
                {
                        while ( fgets(achItemID,100,FileHandle) != NULL)
                        {
                                iCount++;
                                printf("%s\n",achItemID);
                                fflush(stdout);
                        }

                        if ((INT)ulTotalNumItemId != iCount - 2)
                        {
                                printf("Internal Error:  TotalNumItemId <%d>is not match from the file <%d>\n", ulTotalNumItemId, iCount);
                                printf("Delete %s and restore new object\n",buffer);
                                printf("Program Exit\n");
                                fflush(stdout);
                                exit(1);
                        }

                        rc = fclose(FileHandle);
                        printf("\n________________________________________________________________________\n");
                        printf("Total number of ItemID:   :::> [  %d  ]\n", iCount - 2);
                        fflush(stdout);
                }
                else
                {
                        printf("There is no INDEX ID in %s\n",buffer);
                        fflush(stdout);
                }
        }
    return 0;
}





/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function        : FreeMemory                                            */
/*                                                                          */
/*  Description     : This function is called from main() to free memory    */
/*                    allocated as the result of a Folder Manager           */
/*                    SimLibLogon call.                                     */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibFree                        */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  VOID.                                               */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  VOID FreeMemory ( void ).                           */
/*                                                                          */
/*  Return values    :  None.                                               */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Call SimLibFree to free memory allocated by the Folder Manager  */
/*          as a result of SimLibLogon.                                     */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG FreeMemory(VOID)
{
    RCSTRUCT RCStruct;                 /* RC data structure                 */

    /************************************************************************/
    /* Free allocated memory                                                */
    /************************************************************************/
    ulretcode = SimLibFree(hSession,     /* Folder Manager session handle   */
                                   (PVOID)ulMemoryBlock, /* Pointer to memory block to free */
                   (PRCSTRUCT)&RCStruct);/* Pointer to RC data structure    */
    return ulretcode;
}










/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : OpenObject                                           */
/*                                                                          */
/*  Description      : This function is called from main() to open the      */
/*                     object to be replaced.  The existing document part   */
/*                     and replacment object must have the same content     */
/*                     class                                                */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibOpenObject                  */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG OpenObject ( void ).                          */
/*                                                                          */
/*  Return values    :  Return code from SimLibOpenObject.                  */
/*                                                                          */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Initialize SimLibOpenObject parameters.                         */
/*      2.  Call SimLibOpenObject Folder Manager API.                       */
/*      3.  Return to CmdMRetrieve with a return code.                      */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG OpenObject(VOID)
{

    RCSTRUCT RCStruct;                 /* RC data structure                 */
    INT iActionCode;
    CHAR cActionCode;
    /************************************************************************/
    /* Initialize SimLibOpenObject parameters.                              */
    /************************************************************************/
    /************************************************************************/
    /* Object structure.                                                    */
    /************************************************************************/

    memset(&Obj, '\0', sizeof(OBJ));
    Obj.ulStruct = sizeof(Obj);
    Obj.ulPart = ULPARTID;
    strcpy(Obj.szItemID, DocItemID);

    /************************************************************************/
    /* Print Object information.                                            */
    /************************************************************************/

    printf("Item ID of object = /%s/\n", Obj.szItemID);
    printf("Part number of object = %lu\n", Obj.ulPart);
        fflush(stdout);

        if (fMediaObject)
        {
                printf("Enter one of following Action....\n");
                printf("<1> GET_IT \n");
                printf("<2> STAGE_IT \n");
                printf("<3> STAGE_IT_PREFETCH \n");
        printf("\n---> ");
                fflush(stdout);
            iActionCode = getchar();
                while (! isdigit(iActionCode) )
                {
                        printf("%c is an invaild Action code!\n",iActionCode);
                        printf("Please enter 1, 2 or 3\n");
                        printf("<1> GET_IT \n");
                        printf("<2> STAGE_IT \n");
                        printf("<3> STAGE_IT_PREFETCH \n ");
            printf(">> ");
                        fflush(stdout);
                        iActionCode = getchar();
                }
                cActionCode = (char)iActionCode;
                iActionCode = atoi((const char*)&cActionCode);
                fNotperfetch = FALSE;
                switch (iActionCode)
                {
                        case  1 :                  /* The Object is in the Staging Area  */
                                printf("\n---------------GET_IT----------------\n");
                                iActionCode = GET_IT;
                                fNotperfetch = TRUE;
                                break;
                        case  2 :                  /* Copy Object from achive to Staging */
                                printf("\n--------------STAGE_IT---------------\n");
                                iActionCode = STAGE_IT;
                                fNotperfetch = TRUE;
                                break;
                        case  3 :                  /* Copy Object from achive to Staging */
                                printf("\n------------STAGE_IT_PERFETCH--------\n");
                                iActionCode = STAGE_IT_PREFETCH;
                                fNotperfetch = FALSE;
                                break;
                        default  :
                                iActionCode = DATE_ONLY;
                                fNotperfetch = FALSE;
                }
        }
        else
        {                                  /* Default action                     */
                iActionCode = GET_IT;
        }


    /************************************************************************/
    /* Call SimLibOpenObject to open the object.                            */
    /************************************************************************/

    ulretcode = SimLibOpenObject(hSession,/* Folder Manager session handle  */
                                (HOBJ)&Obj,               /* ItemID of object to replace    */
                                SIM_ACCESS_SHARED_READ,   /* Open for reading and writing   */
                                iActionCode,              /* ulRetrAction                   */
                                FALSE,                    /* Reserved for future use        */
                                SIM_OPEN_MEMORY,          /* Open object should be in memory*/
                                (PASYNCCTLSTRUCT)NULL,    /* Request synchronous processing */
                                (PRCSTRUCT)&RCStruct);    /* Pointer to RC data structure   */


    if (RCStruct.ulRC == SIM_RC_OK  && RCStruct.ulParam1)
    {

        ObjectAccessHandle = (HOBJACC)RCStruct.ulParam1;
        printf("New Object Access Handle  = %lu\n\n", ObjectAccessHandle);
        fflush(stdout);
    }


    /************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more       */
    /* detailed diagnostic information.                                     */
    /************************************************************************/

    else
    {
           if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR || RCStruct.ulRC ==
           SIM_RC_DOCSS_ERROR)
           {
                RCStruct.ulRC = RCStruct.ulExtRC;
           }
    }

    /************************************************************************/
    /* Return to CmdMRetrieve() with a return code from OpenObject()        */
    /************************************************************************/

    return (RCStruct.ulRC);
}



/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : QueryMediaIndexAttr                                  */
/*                                                                          */
/*  Description      : This function is called from main() to Query an      */
/*                     Media Index Attributes.                              */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibOpenObject                  */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG QueryMediaIndexAttr( void ).                  */
/*                                                                          */
/*  Return values    :  Return code from SimLibQueryMediaIndexAttr.         */
/*                                                                          */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Initialize SimLibQueryMediaIndexAttr parameters.                */
/*      2.  Call SimLibQueryMediaIndexAttr Folder Manager API.              */
/*      3.  Return to CmdMQuery() with a return code.                       */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG QueryMediaIndexAttr(VOID)
{
    RCSTRUCT RCStruct;                             /* RC data structure                 */
        USHORT          usMediaClassID;    /* FRN$MEDIA class ID                */
        USHORT          pusMediaAttrID[19];/* FRN$MEDIA attributes, array of 19 */
        PMEDIAATTRIBSTRUCT  pMediaAttStruct;

    Obj.ulPart = ULPARTID;             /*  hardcoded for now  JL 08/07/97   */
    strcpy(Obj.szItemID, DocItemID);

    ulretcode = SimLibQueryMediaIndexAttr(hSession,/* Folder Manager session handle     */
                                   &usMediaClassID,                /* FRN$MEDIA class ID                */
                                   pusMediaAttrID,                 /* FRN$MEDIA attributes, array of 19 */
                                   &Obj,
                                   (PRCSTRUCT)&RCStruct);          /* Pointer to RC data structure      */

        if (ulretcode == SIM_RC_OK  && (RCStruct.ulParam1 != 0))
        {

                pMediaAttStruct = (MEDIAATTRIBSTRUCT*)RCStruct.ulParam1;
                printf("\n********************************************************\n");
                printf("ulPartNo:                       %lu  \n",pMediaAttStruct->ulPartNo);
                printf("lMediaState:                    %ld  \n",pMediaAttStruct->lMediaState);
                printf("ulInvalidCommands:              %lu  \n",pMediaAttStruct->ulInvalidCommands);
                printf("ulMediaDurSeconds:              %lu  \n",pMediaAttStruct->ulMediaDurSeconds);
                printf("ulMediaDurFrames:               %lu  \n",pMediaAttStruct->ulMediaDurFrames);
                printf("ulMediaFrameRate:               %lu  \n",pMediaAttStruct->ulMediaFrameRate);
                printf("ulMediaBitRate:                 %lu  \n",pMediaAttStruct->ulMediaBitRate);
                printf("ulCopyRate:                     %lu  \n",pMediaAttStruct->ulCopyRate);
                printf("lNumUsers:                      %ld  \n",pMediaAttStruct->lNumUsers);
                printf("szItemID:                       %s   \n",pMediaAttStruct->szItemID);
                printf("chRepType:                      %s   \n",pMediaAttStruct->chRepType);
                printf("szTimeStamp:                    %s   \n",pMediaAttStruct->szTimeStamp);
                printf("szMediaType:                    %s   \n",pMediaAttStruct->szMediaType);
                printf("szMediaResolution:              %s   \n",pMediaAttStruct->szMediaResolution);
                printf("szMediaStandard:                %s   \n",pMediaAttStruct->szMediaStandard);
                printf("szMediaFormat:                  %s   \n",pMediaAttStruct->szMediaFormat);
                printf("szAssetGroupName:               %s   \n",pMediaAttStruct->szAssetGroupName);
                printf("szReserved1:                    %s   \n",pMediaAttStruct->szReserved1);
                printf("szReserved2:                    %s   \n",pMediaAttStruct->szReserved2);
                printf("*******************************************************\n\n");
                fflush(stdout);

                iObjectState = pMediaAttStruct->lMediaState;

                /*************************************************************************/
                /* If return code (RCStruct.ulParam1) not equal to NULL, call FreeMemory */
                /* to free the memory for structure                                      */
                /*************************************************************************/
                if(RCStruct.ulParam1)
                {
                        ulMemoryBlock=RCStruct.ulParam1;
                        FreeMemory();
                }
        }
        else
        {
                printf("SimLibQueryMediaIndexAttr Error %lu\n",RCStruct.ulRC);
        }

        if(iObjectState == 2)
        {
        printf("Object Ok\n\n\n");
        fflush(stdout);
        }


    /*************************************************************************/
    /*  Return to CmdMQuery() with the                                       */
        /*  return code from QueryMediaIndexAttr().                              */
    /*************************************************************************/

    return (RCStruct.ulRC);
}











/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : ReadObject                                           */
/*                                                                          */
/*  Description      : This function is called from CmdMRetrieve() to read  */
/*                     an object.                                           */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibOpenObject                  */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Return values    :  Return code from SimLibReadObject.                  */
/*                                                                          */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Initialize SimLibReadObject parameters.                         */
/*      2.  Return to CmdMRetrieve() with a return code.                    */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG ReadObject(VOID)
{

    RCSTRUCT RCStruct;                 /* RC data structure                 */
    CHAR *buffer;
        CHAR *pRun;
        INT rc;
        FILE    *FileHandle;               /* File Handle for document.lst      */
        ULONG  ulObjectSize = 0;
        CHAR buff[100];

        sprintf(buff,"%s/view.tmp", achFrnrootPath);


    FileHandle = fopen(buff, "wb");

    if(fMediaObject)
        {
                ulObjectSize = 4000;           /* hardcoded 4000 for now            */
                buffer = (char*)malloc(4000);
                memset(buffer,'\0',sizeof(buffer));
        }
        else
        {
                if (Size  == 0)
                {
                        return 999;
                }
                ulObjectSize = Size;
                buffer = (char*)malloc(Size);
        }
        /************************************************************************/
    /* Call SimLibReadObject to open the object.                            */
    /************************************************************************/

    ulretcode = SimLibReadObject(hSession, /*Folder Manager session handle  */
                                         ObjectAccessHandle,   /*object access handle           */
                                         (PHBUF)buffer,
                                         ulObjectSize,
                                         (PASYNCCTLSTRUCT)NULL,/*Request synchronous processing */
                                         (PRCSTRUCT)&RCStruct);/*Pointer to RC data structure   */



        /* Getting Meta File for Media Object                                   */
    if (RCStruct.ulRC == SIM_RC_OK)
        {
                printf("File       =>  %s\n", DocItemID);
                printf("_________________________________________________________\n");
                printf("%s\n",buffer);
                printf("_________________________________________________________\n");
                fflush(stdout);
                fflush(stdin);


            if(fMediaObject)
                {
                        if (buffer[0] == 'M')                 /* Media Streamer object  */
                        {
                            fVideoChargerObject = FALSE;
                pRun = buffer + MEDIASTREAMERTITLE;
                rc = fwrite(pRun, 1, strlen(buffer)-MEDIASTREAMERTITLE, FileHandle);

                        }
                        else
                        {
                                if (buffer[0] != 'V')             /* None Media Object      */
                                {
                                        fIsMediaObject = FALSE;
                                }
                                else
                                {
                                        fVideoChargerObject = TRUE;   /* Video Charger Object   */
                    pRun = buffer + VIDEOCHARGERTITLE;
                    rc = fwrite(pRun, 1, strlen(buffer)-VIDEOCHARGERTITLE, FileHandle);
                                }
                        }

            rc = fclose(FileHandle);
                        if ((0 == strcmp(achAutoPlayOption,"YES")) && fVideoChargerObject  && fNotperfetch)
                        {
                                printf("call video charger player           =>  %s\n", DocItemID);
                                system(achStartIBMVideoCharger);
                        }
                }
                free(buffer);

        }

    /************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more       */
    /* detailed diagnostic information.                                     */
    /************************************************************************/
    else
    {
        if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR || RCStruct.ulRC ==
           SIM_RC_DOCSS_ERROR)
            RCStruct.ulRC = RCStruct.ulExtRC;
    }

    /************************************************************************/
    /* Return to CmdMRetrieve() with a return code.                         */
    /************************************************************************/

    return (RCStruct.ulRC);
}




/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : CloseObject                                          */
/*                                                                          */
/*  Description      : This function is called from CmdMRetrieve() to close */
/*                     an object.                                           */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibCloseObject                 */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Return values    :  Return code from SimLibCloseObject.                 */
/*                                                                          */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Call SimLibReadObject API.                                      */
/*      2.  Return to CmdMRetrieve() with a return code.                    */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/


ULONG CloseObject(VOID)
{
    RCSTRUCT RCStruct;                 /* RC data structure                 */

    /************************************************************************/
    /* Call SimLibCloseObject to close the object.                          */
    /************************************************************************/

    ulretcode = SimLibCloseObject(hSession,    /* Folder Manager session handle */
                   (HOBJACC)ObjectAccessHandle,/* Object access handle          */
                           (BOOL)fCommit,              /* Update commit flag            */
                   (PASYNCCTLSTRUCT)NULL,      /* Request synchronous processing*/
                   (PRCSTRUCT)&RCStruct);      /* Pointer to RC data structure  */

    /************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more       */
    /* detailed diagnostic information.                                     */
    /************************************************************************/

    if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR || RCStruct.ulRC ==
       SIM_RC_DOCSS_ERROR)
        RCStruct.ulRC = RCStruct.ulExtRC;

        /*************************************************************************/
        /* If return code (RCStruct.ulParam1) not equal to NULL, call FreeMemory */
        /* to free the memory for structure                                      */
        /*************************************************************************/
        if(RCStruct.ulParam1)
        {
                ulMemoryBlock=RCStruct.ulParam1;
                ulretcode = FreeMemory();
                if (ulretcode)
                {
                        printf("Free Memory in CloseObject Error \n");
                fflush(stdout);
                }
        }


    /************************************************************************/
    /* Return to CmdMRetrieve() with a return code.                         */
    /************************************************************************/

    return (RCStruct.ulRC);
}









/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : Logoff                                               */
/*                                                                          */
/*  Description      : This function is called from main() to logoff from   */
/*                     the VisualInfo Folder Manager.                       */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibLogoff()                    */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG Logoff ( void ).                              */
/*                                                                          */
/*  Return values    :  Return code from SimLibLogoff.                      */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Terminate the session with the Folder Manager by calling        */
/*          SimLibLogoff.                                                   */
/*      2.  Return to main() with return code from SimLibLogoff.            */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG Logoff(VOID)
{
    RCSTRUCT RCStruct;                 /* RC data structure                 */

    /************************************************************************/
    /* Call SimLibLogoff to terminate the Folder Manager session.           */
    /************************************************************************/

    ulretcode = SimLibLogoff(hSession,   /* Folder Manager session handle   */
                   (PASYNCCTLSTRUCT)NULL,/* Request synchronous processing  */
                   (PRCSTRUCT)&RCStruct);/* Pointer to RC data structure    */


        /*************************************************************************/
        /* If return code (RCStruct.ulParam1) not equal to NULL, call FreeMemory */
        /* to free the memory for structure                                      */
        /*************************************************************************/
        if(RCStruct.ulParam1)
        {
                ulMemoryBlock=RCStruct.ulParam1;
                FreeMemory();
        }

    /************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more       */
    /* detailed diagnostic information.                                     */
    /************************************************************************/

        if (RCStruct.ulRC == SIM_RC_OK)
        {
                fLogon = FALSE;
        }

    if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR || RCStruct.ulRC ==
       SIM_RC_DOCSS_ERROR)
    {
        RCStruct.ulRC = RCStruct.ulExtRC;
        }
    /************************************************************************/
    /* Return to main() with the return code from SimLibLogoff.             */
    /************************************************************************/

    return (RCStruct.ulRC);

}


/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : DeleteMediaObject                                    */
/*                                                                          */
/*  Description      : This function is called from CmdMDiscard() to delete */
/*                     an  existing object.                                 */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibDeleteObject                */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  parm.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Return values    :  Return code from SimLibDeleteObject.                */
/*                                                                          */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Initialize SimLibDeleteObject parameters.                       */
/*      2.  Return to CmdMDiscard() with a return code.                     */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/
ULONG DeleteMediaObject ( CHAR* parm )
{
    RCSTRUCT        RCStruct;            /* RCStruct data structure         */
    ULONG           ulRC = SIM_RC_OK;
    ULONG           ulAffiliatedType = SIM_BASE;
    PVOID           pAffiliatedData = NULL;
    PSZ             pszLibSrvrName = "libsrvrn";
    PSZ             pszUserID = "UserId";
    PSZ             pszPassword = "Password";

// Attribute Values for NOINDEX Class
    PSZ             pszAttribSource = "source1";
    PSZ             pszAttribUserid = "UserId";
    PSZ             pszAttribTime = "1998-01-11-12.39.00.000000";

    USHORT          usNumOfAttrs=3;
    USHORT          usIndexClass=6;
    ULONG           ulDeleteOption = 7; /* hardcoded for now  WB - 6/26/97 */

        Count = atoi(parm);
        if (((ULONG)Count > ulTotalNumItemId  && fMediaObject) || Count < 1)
        {
                return ERR_OUTOFRANGE;
        }

        ReadItemName(Count);

        strcpy(Obj.szItemID, DocItemID);
    Obj.ulPart = 1;

    /**************************************************************************/
    /* Call SimLibDeleteObject                                                */
    /**************************************************************************/

    ulretcode = SimLibDeleteObject (hSession,/* handle to a session           */
                   &Obj,                                         /* Ptr to object handle block    */
                   SIM_DROPITEM_MEDIA_AVAIL, /* delete option                 */
                   NULL,                                         /*     Pointer to asynchronous control block.*/
                   &RCStruct);                           /*     Pointer to return data structure.*/


    /*************************************************************************/
    /* Save the new folder ItemId for use in SimLibAddFolderItem API call    */
    /* and to free the memory. Print the new folder ItemID.                  */
    /*************************************************************************/
    if  (ulretcode == SIM_RC_OK)
        {
       printf("Delete successful!\n");
       DumpRC(&RCStruct);
       DeleteItemName(Count);
    }

        /*************************************************************************/
        /* If return code (RCStruct.ulParam1) not equal to NULL, call FreeMemory */
        /* to free the memory for structure                                      */
        /*************************************************************************/
        if(RCStruct.ulParam1)
        {
                ulMemoryBlock=RCStruct.ulParam1;
                FreeMemory();
        }

    /*************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more        */
    /* detailed diagnostic information.                                      */
    /*************************************************************************/
    else
    {
         if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR ||
             RCStruct.ulRC == SIM_RC_DOCSS_ERROR)
                 {
             RCStruct.ulRC =  RCStruct.ulExtRC;
                         printf("Delete failed!  RC = %x, hErrLog = %x \n", ulRC, RCStruct.hErrLog);
                     fflush(stdout);
             DumpRC(&RCStruct);
             return (ulretcode);
         }
        }
    /*************************************************************************/
    /*  Return to CmdMDiscard() with the return code from DeleteMediaObject()*/
    /*************************************************************************/

     return( RCStruct.ulRC );
}




/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : LoadMediaObject                                      */
/*                                                                          */
/*  Description      : This function is called from CmdMstore() to store    */
/*                     a Media Object                                       */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibLoadMediaObject             */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG LoadMediaObject ( void ).                     */
/*                                                                          */
/*  Return values    :  return code from LoadMediaObject                    */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Initialize SimLibLoadMediaObject parameters.                    */
/*      2.  Return to CmdMStore() with a return code.                       */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/
ULONG LoadMediaObject (CHAR* achinFileName)
{
    RCSTRUCT        RCStruct;            /* RCStruct data structure        */
    MEDIAUSERDATA   MediaUserData;
    OBJ             Obj1;
    ULONG           ulRC = SIM_RC_OK;
    ULONG           ulOption = LIST_OF_OBJECT_SEGMENTS;
    ULONG           ulConCls = SIM_CC_ASCII;  /* or use SIM_CC_TEXT        */
    ULONG           ulAffiliatedType = SIM_BASE;
    PVOID           pAffiliatedData = NULL;
    CHAR            achFileName[1024];
        CHAR            achFtpHostName[1024] = "achhostname";
        CHAR            achFtpUserid[1024] = "achuserid";
    CHAR            achFtpPassword[1024] = "achpassword";
    CHAR            achLibSrvrName[1024] = "libsrvrn";
    CHAR            achUserID[1024] = "frnadmin";
    CHAR            achPassword[1024] = "password";

// Attribute Values for NOINDEX Class

    CHAR            achAttribSource[1024] = "source1";
    CHAR            achAttribUserid[1024] = "UserId";
    CHAR            achAttribTime[1024] = "1997-06-11-12.39.00.000000";
        CHAR            buffer[100];
    ITEMID          CreatedItemID;
    ITEMID          CreatedMediaItemID;

    ATTRLISTSTRUCT  NOINDEXAttr[3];
    PATTRLISTSTRUCT pAttributeList;
    USHORT          usNumOfAttrs=3;
    USHORT          usIndexClass=6;

        FILE *          stream;/*INPUT file that contains input data for testcase*/

    /*************************************************************************/
    /* Initialize parameters.                                                */
    /*************************************************************************/

    strcpy(MediaUserData.achAssetGroupName, "asset1");
    strcpy(MediaUserData.achMediaType, "MPEG1");
    strcpy(MediaUserData.achMediaResolution, "SIF");
    strcpy(MediaUserData.achMediaStandard, "NTSC");
    strcpy(MediaUserData.achMediaFormat, "SYSTEM");
    MediaUserData.ulCopyRate = 0;
    MediaUserData.ulInvalidCommands = 20;
    MediaUserData.ulMediaDurSeconds = 30;
    MediaUserData.ulMediaDurFrames = 46;
    MediaUserData.ulMediaFrameRate = 2900;
    MediaUserData.ulMediaBitRate = 1536000;
    MediaUserData.lNumUsers = 1;

        memset(&RCStruct, 0, sizeof(RCSTRUCT));
    memset (&Obj1, 0, sizeof(OBJ));     /* Initialize refernece Obj handle  */
    Obj1.ulStruct = sizeof(OBJ);
    Obj1.ulPart = 0;
    Obj1.sVersion = 0;
    Obj1.chRepType[0] = 0;

    pAttributeList = &NOINDEXAttr[0];
    NOINDEXAttr[0].ulStruct = sizeof(ATTRLISTSTRUCT);

    NOINDEXAttr[0].pszAttributeValue = achAttribSource;
    NOINDEXAttr[0].fAttrFlags = SIM_ATTR_READABLE | SIM_ATTR_WRITEABLE;
    NOINDEXAttr[0].usAttrId = 40;
    NOINDEXAttr[0].usAttrType = SIM_ATTR_VSTRING;

    NOINDEXAttr[1].ulStruct = sizeof(ATTRLISTSTRUCT);
    NOINDEXAttr[1].pszAttributeValue = achAttribUserid;
    NOINDEXAttr[1].fAttrFlags = SIM_ATTR_READABLE | SIM_ATTR_WRITEABLE;
    NOINDEXAttr[1].usAttrId = 41;
    NOINDEXAttr[1].usAttrType = SIM_ATTR_VSTRING;

        NOINDEXAttr[2].ulStruct = sizeof(ATTRLISTSTRUCT);
    NOINDEXAttr[2].pszAttributeValue = achAttribTime;
    NOINDEXAttr[2].fAttrFlags = SIM_ATTR_READABLE | SIM_ATTR_WRITEABLE;
    NOINDEXAttr[2].usAttrId = 42;
    NOINDEXAttr[2].usAttrType = SIM_ATTR_TIMESTAMP;

    /*************************************************************************/
    /* Read from input file for test parameters                              */
    /*************************************************************************/
    printf ("***** Create Item *****\n");
        fflush(stdout);
/*        sprintf(buffer,"%s/mclient.in", achFrnrootPath); */
        sprintf(buffer,"%s/mclient.in", achFrnrootPath);
    stream = fopen(buffer, "r");

    if (stream == NULL)
    {
      printf("fopen Failed !\n ");
      printf("Can Not open file:  :::::::>>> %s\n",buffer);
          fflush(stdout);
      return(ERR_FILE_NOT_FOUND);
    }
    else
    {
    fscanf(stream, "%s %s %u %s %u %s %s %s %s %s %u %u %u %u %u %u %u %s %s %s",
                                     achUserID,
                                     achPassword,
                                     &Obj1.ulPart,
                                     achFileName,
                                     &ulOption,
                                     MediaUserData.achAssetGroupName,
                                     MediaUserData.achMediaType,
                                     MediaUserData.achMediaResolution,
                                     MediaUserData.achMediaStandard,
                                     MediaUserData.achMediaFormat,
                                     &MediaUserData.ulCopyRate,
                                     &MediaUserData.ulInvalidCommands,
                                     &MediaUserData.ulMediaDurSeconds,
                                     &MediaUserData.ulMediaDurFrames,
                                     &MediaUserData.ulMediaFrameRate,
                                     &MediaUserData.ulMediaBitRate,
                                     &MediaUserData.lNumUsers,
                                     achFtpHostName,
                                     achFtpUserid,
                                     achFtpPassword);
    fclose(stream);
    }

        if ( achinFileName != NULL)
        {
            ulOption = 1;
                strcpy (achFileName,achinFileName);
        }

    /*************************************************************************/
    /* Call SimLibLoadMediaObject                                            */
    /*************************************************************************/
    ulRC = SimLibLoadMediaObject( hSession,
                  pAttributeList,   // Ptr to an array of ATTRLISTSTRUCT
                  usNumOfAttrs,     // Number of structures in pAttributeList array
                  usIndexClass,     // Index class
                  0,                // Ptr to item ID of pre existing ITEM
                  &Obj1,            // Ptr to object handle block
                  ulConCls,         // Content class ID
                  ulAffiliatedType, // Type of affliated object
                  pAffiliatedData,  // Ptr to data structure
                  achFileName,      // Ptr to filename
                  ulOption,         // SINGLE_OBJECT orr LIST_OF_OBJECT_SEGMENTS
                  &MediaUserData,   // Data structure for Media object data
                  achFtpHostName,   // host name of where media file exists for ftp
                  achFtpUserid,     // FTP userid for hostname above
                  achFtpPassword,   // FTP password for userid above
                  NULL,             // Pointer to asynchronous control block.
                  &RCStruct);       // Pointer to return data structure.

    /*************************************************************************/
    /* Save the new folder ItemId for use in SimLibAddFolderItem API call    */
    /* and to free the memory. Print the new folder ItemID.                  */
    /*************************************************************************/
    if  (ulRC == SIM_RC_OK  && RCStruct.ulParam1)
        {
       printf("..............................................................\n");
       printf("Create successful!\n");
       strncpy (CreatedItemID, (PSZ)RCStruct.ulParam1, DOC_ID_SIZE);
       strncpy (CreatedMediaItemID, (PSZ)RCStruct.ulParam2, DOC_ID_SIZE);
       printf("New ItemID            = %s\n", CreatedItemID);
       printf("New FRN$MEDIA ItemID  = %s\n", CreatedMediaItemID);
       WriteItemName(CreatedItemID,CreatedMediaItemID);
       printf("..............................................................\n\n");
           fflush(stdout);
           /*************************************************************************/
       /* If return code (RCStruct.ulParam1) not equal to NULL, call FreeMemory */
           /* to free the memory for structure                                      */
           /*************************************************************************/
           if(RCStruct.ulParam1)
           {
                        ulMemoryBlock=RCStruct.ulParam1;
                        FreeMemory();
           }

    }
    /*************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more        */
    /* detailed diagnostic information.                                      */
    /*************************************************************************/
    else
    {
         if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR ||
             RCStruct.ulRC == SIM_RC_DOCSS_ERROR)
                 {
             RCStruct.ulRC =  RCStruct.ulExtRC;
                 }
         printf("Create failed!  RCStruct = %d, hErrLog = %x \n", ulRC, RCStruct.hErrLog);
         printf("New ItemID            = %s\n", CreatedItemID);
         printf("New FRN$MEDIA ItemID = %s\n", CreatedMediaItemID);
                 fflush(stdout);
         DumpRC(&RCStruct);
         return (RCStruct.ulRC);   /*jim, change Return Code from ulRC to RCStruct.ulRC */
    }

    /*************************************************************************/
    /*  Return to CmdMStore with the return code from LoadMediaObject().     */
    /*************************************************************************/

     return( RCStruct.ulRC );
}



/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : Logon                                                */
/*                                                                          */
/*  Description      : This function is called from main() to logon to      */
/*                     VisualInfo Folder Manager.                           */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibLogon                       */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG Logon ( void ).                               */
/*                                                                          */
/*  Return values    :  SIM_RC_OUT_OF_MEMORY or the return code from        */
/*                      SimLibLogon.                                        */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Reserve storage for and initialize SimLibLogon parameters.      */
/*      2.  If sufficient storage is available, establish a session         */
/*           with the Folder Manager by calling SimLibLogon.                */
/*      3.  Return to main() with a return code.                            */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG Logon(CHAR* pszLibsrvrName)
{
    PSZ                 pszDBName;             /* Pointer to Database name          */
    PSZ                 pszUserId;             /* Pointer to User Id                */
    PSZ                 pszPassword;           /* Pointer to Password for User Id   */
    RCSTRUCT    RCStruct;              /* RC data structure                 */
        CHAR            buffer[100];
    FILE*               FileHandle;/*INPUT file that contains inputdata for testcase*/



    /************************************************************************/
    /* Reserve and initialize storage for SimLibLogon parameters. Print     */
    /* error message if sufficient storage is not available.                */
    /************************************************************************/

    RCStruct.ulRC = SIM_RC_OK;

    pszDBName = (PSZ)malloc(SIM_SERVER_NAME_LENGTH+1);
    if (pszDBName == NULL)
    {
        printf("Memory allocation error for pszDBName.\n");
        RCStruct.ulRC = SIM_RC_OUT_OF_MEMORY;
    }
    else
    {
        memset(pszDBName, '\0', SIM_SERVER_NAME_LENGTH+1);
        pszUserId = (PSZ)malloc(OIM_MAXIMUM_USERID_LENGTH+1);
        if (pszUserId == NULL)
        {
            printf("Memory allocation error for pszUserId.\n");
            RCStruct.ulRC = SIM_RC_OUT_OF_MEMORY;
        }
        else
        {
            memset(pszUserId, '\0', OIM_MAXIMUM_USERID_LENGTH+1);
            pszPassword = (PSZ)malloc(OIM_MAX_PASSWORD_LENGTH+1);
            if (pszPassword == NULL)
            {
                printf("Memory allocation error for pszPassword.\n");
                        fflush(stdout);
                RCStruct.ulRC = SIM_RC_OUT_OF_MEMORY;
            }
            else
            {
                memset(pszPassword, '\0', OIM_MAX_PASSWORD_LENGTH+1);

                /************************************************************/
                /* Initialize SimLibLogon parameters.                       */
                /************************************************************/

                                sprintf(buffer,"%s/mclient.in", achFrnrootPath);
                                FileHandle = fopen(buffer, "r");

                                strcpy (pszDBName,pszLibsrvrName);
                if (FileHandle == NULL)
                {
                  printf("fopen Failed !\n ");
                  printf("Can Not open file:  %s \n",buffer);
                          fflush(stdout);
                  return(ERR_FILE_NOT_FOUND);
                }
                else
                {
                  fscanf(FileHandle, "%s %s",
                                             pszUserId,
                                             pszPassword);
                  fclose(FileHandle);

                                }
            }
        }
    }
    if (RCStruct.ulRC == SIM_RC_OK)
    {

        /********************************************************************/
        /* Call SimLibLogon to establish a Folder Manager session.          */
        /********************************************************************/

        SimLibLogon(pszDBName,         /* Pointer to Database name          */
           (PSZ)"",                    /* Reserved for future use           */
           pszUserId,                  /* Pointer to User Id                */
           pszPassword,                /* Pointer to Password for User Id   */
           (PSZ)NULL,                  /* Logon without new password        */
           (PSZ)NULL,                  /* Reserved for future use           */
           (PSZ)NULL,                  /* Reserved for future use           */
           SIM_SS_NORMAL,              /* Non-configuration session logon   */
           (PASYNCCTLSTRUCT)NULL,      /* Request synchronous processing    */
           (PRCSTRUCT)&RCStruct);      /* Pointer to RC data structure      */

        if ((RCStruct.ulRC == SIM_RC_OK) ||
                        (RCStruct.ulRC == SIM_RC_GRACE_PERIOD_UNDER_LIMIT)  ||
                        (RCStruct.ulRC == SIM_RC_GRACE_PERIOD_OVER_LIMIT)   ||
                        (RCStruct.ulRC == SIM_RC_GRACE_PERIOD_ENDED))

            /****************************************************************/
            /* If successful, save the Folder Manager session handle for    */
            /* subsequent Folder Manager API calls.                         */
            /****************************************************************/

        {
            RCStruct.ulRC = SIM_RC_OK;
            hSession = RCStruct.ulParam1;
                        fLogon = TRUE;
                        strcpy (pszDataBase,pszLibsrvrName);
                        printf("%s > >> >>> >>>> Logon to %s is OK.\n",pszUserId,pszLibsrvrName);
                    fflush(stdout);
            /****************************************************************/
            /* Save the pointer to the USERLOGONINFOSTRUCT data structure in*/
            /* order to free the memory.                                    */
            /****************************************************************/

            ulMemoryBlock = RCStruct.ulParam2;
        }

        /********************************************************************/
        /* If RCStruct.ulRC indicates a library or server error, get more   */
        /* detailed diagnostic information.                                 */
        /********************************************************************/

        else
        {
                        fLogon = FALSE;
            if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR || RCStruct.ulRC ==
               SIM_RC_DOCSS_ERROR)
                        {
                RCStruct.ulRC = RCStruct.ulExtRC;
                        }
                        DumpRC(&RCStruct);
        }
    }

    /************************************************************************/
    /* Free storage reserved with malloc and return to main() with a return */
    /* code.                                                                */
    /************************************************************************/

    free(pszDBName);
    free(pszUserId);
    free(pszPassword);

    /*************************************************************************/
    /*  Return to CmdMUse() with the return code from Logon()                */
    /*************************************************************************/

    return (RCStruct.ulRC);

}




/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : QueryObject                                          */
/*                                                                          */
/*  Description      : This function is called from main() to Query an Open */
/*                     object.                                              */
/*                                                                          */
/*  Dependencies     : Global Variables :                                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibOpenObject                  */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG.                                              */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG QueryObject( void ).                          */
/*                                                                          */
/*  Return values    :  Return code from SimLibQueryObject.                 */
/*                                                                          */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Initialize SimLibQueryObject parameters.                        */
/*      2.  Call SimLibQueryObject Folder Manager API.                      */
/*      3.  Return to CmdQuery() with a return code.                        */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG QueryObject(VOID)
{
    RCSTRUCT RCStruct;                 /* RC data structure                 */
    POBJINFOSTRUCT pObjInfo;           /* Pointer to  Object info structure */

     /********************************/
     /* Object structure.            */
     /********************************/

     memset (&Obj, '\0', sizeof(OBJ));
     Obj.ulStruct  = sizeof(Obj);
     Obj.ulPart    = ULPARTID;

     /*********************************************************/
     /* Create object as part of previously created document. */
     /*********************************************************/

     strcpy (Obj.szItemID, DocItemID);




    /************************************************************************/
    /* Call SimLibQueryObject to open the object.                           */
    /************************************************************************/

    SimLibQueryObject(hSession,        /* Folder Manager session handle     */
       (HOBJ)&Obj,                     /* object access handle              */
       (PASYNCCTLSTRUCT)NULL,          /* Request synchronous processing    */
       (PRCSTRUCT)&RCStruct);          /* Pointer to RC data structure      */

    /************************************************************************/
    /* Save the object access handle for subsequent references to the       */
    /* object.                                                              */
    /************************************************************************/

    if (RCStruct.ulRC == SIM_RC_OK  && RCStruct.ulParam1)
    {
        pObjInfo = (POBJINFOSTRUCT)RCStruct.ulParam1;
        Size = pObjInfo->ulObjSize;
                printf("\nQuery Attributes:\n");
                printf("\n*******************************************************\n");
                printf("ulStruct:                       %lu  \n",pObjInfo->ulStruct);
                printf("ulObjSize:                      %lu  \n",pObjInfo->ulObjSize);
                printf("lSMSRetention:                  %ld  \n",pObjInfo->lSMSRetention);
                printf("lEstimateRetrieveTime:          %ld  \n",pObjInfo->lEstimateRetrieveTime);
                printf("ulAvail:                        %lu  \n",pObjInfo->ulAvail);
                printf("ulObjConCls:                    %lu  \n",pObjInfo->ulObjConCls);
                printf("usPageNum:                      %d   \n",pObjInfo->usPageNum);
                printf("tsCreate:                       %s   \n",pObjInfo->tsCreate);
                printf("tsExpiration:                   %s   \n",pObjInfo->tsExpiration);
                printf("tsLastRef:                      %s   \n",pObjInfo->tsLastRef);
                printf("tsModify:                       %s   \n",pObjInfo->tsModify);
                printf("tsEnterSG:                      %s   \n",pObjInfo->tsEnterSG);
                printf("tsEnterSC:                      %s   \n",pObjInfo->tsEnterSC);
                printf("szCollectionName:               %s   \n",pObjInfo->szCollectionName);
                printf("szObjectName:                   %s   \n",pObjInfo->szObjectName);
                printf("szMgtCls:                       %s   \n",pObjInfo->szMgtCls);
                printf("szDataCls:                      %s   \n",pObjInfo->szDataCls);
                printf("szStoreSite:                    %s   \n",pObjInfo->szStoreSite);
                printf("*******************************************************\n\n");
    }

    /************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more       */
    /* detailed diagnostic information.                                     */
    /************************************************************************/

    else
    {
        if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR || RCStruct.ulRC ==
           SIM_RC_DOCSS_ERROR)
            RCStruct.ulRC = RCStruct.ulExtRC;
    }

    /************************************************************************/
    /* Return to main() with a return code.                                 */
    /************************************************************************/

    return (RCStruct.ulRC);
}








/*BEGINPROLOGUE***************************************************************/
/*                                                                           */
/*  Function         : LoadObject                                            */
/*                                                                           */
/*  Description      : This function is called from main() to store a new    */
/*                     object using an existing file.  The new object will be*/
/*                     stored as a part of the previously created document.  */
/*                     To run this sample code without modification,         */
/*                     the object must have a content class of OS/2          */
/*                     Version 2 bitmap.                                     */
/*                                                                           */
/*  Dependencies     : Global Variables :                                    */
/*                     Static External  :                                    */
/*                     Includes         :                                    */
/*                     Product Functions: SimLibCatalogObject                */
/*                                                                           */
/*  Restrictions     :  None.                                                */
/*                                                                           */
/*  Function type    :  ULONG.                                               */
/*                                                                           */
/*  Input Parameters :  None.                                                */
/*                                                                           */
/*  Output Parameters:  None.                                                */
/*                                                                           */
/*  Synopsis         :  ULONG LoadObject (void ).                            */
/*                                                                           */
/*  Return values    :  SIM_RC_OUT_OF_MEMORY or the return code from         */
/*                      SimLibCatalogObject.                                 */
/*                                                                           */
/*                                                                           */
/*  Process Flow     :                                                       */
/*                                                                           */
/*      1.  Reserve storage for and initialize SimLibCatalogObject           */
/*          parameters.                                                      */
/*      2.  If sufficient storage is available, call the SimLibCatalogObject */
/*          API.                                                             */
/*      3.  Return to main() with a return code.                             */
/*                                                                           */
/*  Notes            :  None.                                                */
/*                                                                           */
/*ENDPROLOGUE*****************************************************************/

ULONG LoadObject (CHAR * pszFileName)
{
     OBJ      Obj;                         /* Object data structure          */
     PSZ      pszFullFileName;             /* Path & file name of object     */
     RCSTRUCT RCStruct;                    /* RC data structure              */

    /*************************************************************************/
    /* Initialize SimLibCatalogObject Parameters.                            */
    /*************************************************************************/

     RCStruct.ulRC = SIM_RC_OK;

     /********************************/
     /* Object structure.            */
     /********************************/

     memset (&Obj, '\0', sizeof(OBJ));
     Obj.ulStruct  = sizeof(Obj);
     Obj.ulPart    = ULPARTID;

     /*********************************************************/
     /* Create object as part of previously created document. */
     /*********************************************************/

     strcpy (Obj.szItemID, DocItemID);

    /*************************************************************************/
    /* Reserve and initialize storage for pszFullFileName parameter.         */
    /* Print error message is sufficient storage is not available.           */
    /*************************************************************************/

     pszFullFileName = (PSZ) malloc (MAXFULLFILENAME);
     if (pszFullFileName == NULL)
     {
        printf("Memory allocation error for pszFullFileName.\n");
        RCStruct.ulRC = SIM_RC_OUT_OF_MEMORY;
     }
     else
     {
        memset (pszFullFileName, '\0', MAXFULLFILENAME);
        strcpy (pszFullFileName, pszFileName);
        if(outputFlag)
                {
           printf("File to be stored         = %s\n\n", pszFullFileName);
                }
     }

     if (RCStruct.ulRC == SIM_RC_OK)
     {

    /*************************************************************************/
    /* Call SimLibCatalogObject to create a new object using an existing file*/
    /*************************************************************************/

     SimLibCatalogObject( hSession,      /* Folder Manager session handle    */
          (HOBJ) &Obj,                   /* Pointer to object handle block   */
//          SIM_CC_OS2V2_BMP,            /* OS/2 V2 bitmap content class     */
          SIM_CC_ASCII,                  /* Ascii Text File content class    */
          (PSMS) NULL,                   /* Pointer to SMS object structure  */
          (PSZ) pszFullFileName,         /* Name of existing file            */
          SIM_PRI_NORMAL,                /* Medium servicing priority        */
          SIM_CLOSE,                     /* Close object upon completion     */
          (ULONG)NULL,                   /* Reserved for future use          */
          (LONG)NULL,                    /* Reserved for future use          */
          SIM_BASE,                      /* Define object type as base       */
          (PVOID)NULL,                   /* No affiliated data               */
          (PASYNCCTLSTRUCT) NULL,        /* Request synchronous processing   */
          (PRCSTRUCT) &RCStruct );       /* Pointer to RC data structure     */

    /*************************************************************************/
    /* Save the pointer to the object handle in order to free the memory.    */
    /* If subsequent references to the object are required, ulParam1 must    */
    /* be saved.                                                             */
    /*************************************************************************/

     if (RCStruct.ulRC == SIM_RC_OK && RCStruct.ulParam1)
         {
         if(outputFlag)
         printf("New Object Handle  = %lu\n\n", (HOBJ)RCStruct.ulParam1);
         ulMemoryBlock = RCStruct.ulParam1;
                 WriteItemName(DocItemID,"NULL");
         }

    /*************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more        */
    /* detailed diagnostic information.                                      */
    /*************************************************************************/

     else
         {
         if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR ||
             RCStruct.ulRC == SIM_RC_DOCSS_ERROR)
             RCStruct.ulRC =  RCStruct.ulExtRC;
         }
     }

    /*************************************************************************/
    /*  Free storage reserved with malloc and return to main() with a return */
    /*  code.                                                                */
    /*************************************************************************/

     free (pszFullFileName);

     return( RCStruct.ulRC );
}




/*BEGINPROLOGUE***************************************************************/
/*                                                                           */
/*  Function         : CreateDocumentItemID                                  */
/*                                                                           */
/*  Description      : This function is called from main() to create a       */
/*                     document with specified attributes.                   */
/*                                                                           */
/*  Dependencies     : Global Variables :                                    */
/*                     Static External  :                                    */
/*                     Includes         :                                    */
/*                     Product Functions: SimLibCreateItem                   */
/*                                                                           */
/*  Restrictions     :  None.                                                */
/*                                                                           */
/*  Function type    :  ULONG.                                               */
/*                                                                           */
/*  Input Parameters :  None.                                                */
/*                                                                           */
/*  Output Parameters:  None.                                                */
/*                                                                           */
/*  Synopsis         :  ULONG CreateDocumentItemID ( void ).                 */
/*                                                                           */
/*  Return values    :  Return code from SimLibCreateItem.                   */
/*                                                                           */
/*                                                                           */
/*  Process Flow     :                                                       */
/*                                                                           */
/*      1.  Initialize SimLibCreateItem parameters.                          */
/*      2.  Call SimLibCreateItem Folder Manager API.                        */
/*      3.  Return to main() with the return code from SimLibCreateItem.     */
/*                                                                           */
/*  Notes            :  None.                                                */
/*                                                                           */
/*ENDPROLOGUE*****************************************************************/

ULONG CreateDocumentItemID ( VOID )
{
     USHORT         usDocuAttrs;                /* Number of ATTRLISTSTRUCTs */
     ATTRLISTSTRUCT Docu [USDOCUATTRS];         /* Document Attributes       */
     USHORT         usIndexClass;               /* Index class id for docu   */
     RCSTRUCT       RCStruct;                   /* RC data structure         */
     USHORT         count;                      /* Loop counter              */

    /*************************************************************************/
    /* Initialize SimLibCreateItem Parameters.                               */
    /*************************************************************************/

     usDocuAttrs  = USDOCUATTRS;
     usIndexClass = SIM_INDEX_NOINDEX;

    /******************************************************/
    /* Initialize and print Document Attribute structure. */
    /******************************************************/

     memset (Docu, '\0', sizeof(Docu));
     if(outputFlag)
        printf ("Document attribute list :\n\n");
        for ( count = 0 ;
              count < usDocuAttrs;
              count ++
            )
            {
            Docu[count] = DOCU[count];
         // if(count==0) Docu[count].pszAttributeValue=&pszUserid[0];
         //   if(count==1) Docu[count].pszAttributeValue=&pszUserid[0];
                    if(count==1) Docu[count].pszAttributeValue="DLCLIENT";
            if(outputFlag)
            {
             printf("Attribute value = %s\n",
                    Docu[count].pszAttributeValue);
             printf("Attribute ID    = %hu\n",
                    Docu[count].usAttrId);
             printf("Attribute type  = %hu\n",
                    Docu[count].usAttrType);
             printf("Attribute flags = %u\n\n",
                    Docu[count].fAttrFlags);
            }
         }
    /*************************************************************************/
    /* Call SimLibCreateItem to create a document ItemID.                    */
    /*************************************************************************/

     SimLibCreateItem( hSession,           /* Folder Manager session handle  */
          SIM_DOCUMENT,                    /* Create a document              */
          (USHORT) usIndexClass,           /* Index class of document        */
          (USHORT) usDocuAttrs,            /* Number of AttributeLists       */
          (PATTRLISTSTRUCT) &Docu,         /* Pointer to AttributeList       */
          (ULONG)NULL,                     /* Reserved for future use        */
          (PASYNCCTLSTRUCT) NULL,          /* Request synchronous processing */
          (PRCSTRUCT) &RCStruct );         /* Pointer to RC data structure   */

    /*************************************************************************/
    /* Save the new document ItemId for use in SimLibAddFolderItem API call  */
    /* and to free the memory. Print the new document ItemID.                */
    /*************************************************************************/

     if (RCStruct.ulRC == SIM_RC_OK)
         {
            strncpy ((PSZ)DocItemID, (PSZ)RCStruct.ulParam1, DOC_ID_SIZE);
            if(outputFlag)
               printf("New Document ItemID       = %s\n\n", (PSZ)DocItemID);
#ifdef _Windows
            SetItemId((PSZ)DocumentItemID);
#endif
         ulMemoryBlock     = RCStruct.ulParam1;
         }

    /*************************************************************************/
    /* If RCStruct.ulRC indicates a library or server error, get more        */
    /* detailed diagnostic information.                                      */
    /*************************************************************************/

     else
         {
         if (RCStruct.ulRC == SIM_RC_LIB_CLIENT_ERROR ||
             RCStruct.ulRC == SIM_RC_DOCSS_ERROR)
             RCStruct.ulRC =  RCStruct.ulExtRC;
         }

    /*************************************************************************/
    /*  Return to main() with the return code from SimLibCreateItem.         */
    /*************************************************************************/

     return( RCStruct.ulRC );
}







/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : OpenItemAttribute                                    */
/*                                                                          */
/*  Description      : This function is called from CmdUpdateMAttributes()  */
/*                     to Open Item Attribute Session                       */
/*                     SimLibLogon call.                                    */
/*                                                                          */
/*  Dependencies     : Global Variables : hItem, hSession, MediaIndexID     */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibOpenItemAttr                */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG                                               */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG OpenItemAttribute(USHORT usMediaClassID)      */
/*                                                                          */
/*  Return values    :  None.                                               */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Call SimLibOpenItemAttr to Open a session                       */
/*      2.  Getting hItem Handle                                            */
/*      3.  Return to caller with return code                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG OpenItemAttribute(USHORT usMediaClassID)
{

        ULONG                   ulRC;               /* Return Code from Folder Manager API  */
    RCSTRUCT        RCStruct;           /* RC data structure                    */

        ulRC = SimLibOpenItemAttr(
                        hSession,                               /*Handle to a folder manager session.   */
                                &MediaIndexID,                  /*Pointer to a Media item ID.           */
                                usMediaClassID,             /*Index class ID.                       */
                                SIM_ACCESS_READ_WRITE,  /*Desired access level.                 */
                                (PASYNCCTLSTRUCT)NULL,  /*Pointer to asynchronous control block.*/
                                (PRCSTRUCT)  &RCStruct);/*Pointer to return data structure.     */

        if (RCStruct.ulRC == SIM_RC_OK && ulRC == SIM_RC_OK && RCStruct.ulParam1)
        {
                hItem = (HITEM)RCStruct.ulParam1;
        }
        else                                /* SimeLibOpenItemAttr Error            */
        {
                printf("SimLibOpenItemAttr error %lu\n", ulRC);
                DumpRC(&RCStruct);
        }

        return RCStruct.ulRC;
}



/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : ReadAttribute                                        */
/*                                                                          */
/*  Description      : This function is called from CmdUpdateMAttributes()  */
/*                     to Read Item Attributes.                             */
/*                                                                          */
/*  Dependencies     : Global Variables : hItem, hSession                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibReadAttr                    */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG                                               */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG ReadAttribute(USHORT usAttrIndentifer)        */
/*                                                                          */
/*  Return values    :  None.                                               */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Call SimLibReadAttr to Read each unique attribute value         */
/*      2.  Return to caller with return code                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/

ULONG ReadAttribute(USHORT usAttrIdentifer )
{
        ULONG                   ulRC;                 /* Return Code from Folder Manager API*/
    RCSTRUCT        RCStruct;                 /* RC data structure                  */
        CHAR            szAttributeValue[100];/* Attribute Value                    */

        ulRC = SimLibReadAttr(
                                hSession,                          /*Handle to a folder manager session.    */
                                hItem,                             /*Handle to a virtual item.              */
                                usAttrIdentifer,           /*Unique attribute identifier.           */
                                (PASYNCCTLSTRUCT)NULL, /*Pointer to asynchronous control block. */
                                (PRCSTRUCT) &RCStruct);/*Pointer to return data structure.      */


        if (RCStruct.ulRC == SIM_RC_OK)
        {
                strncpy (szAttributeValue, (PSZ)RCStruct.ulParam1, 100);
                printf("%s  %s\n",AttributeIDs[usAttrIdentifer],szAttributeValue);
                fflush(stdout);
        }
        else                               /* SimLibReadAttr Error                  */
        {
                printf("SimLibReadAttr Error %lu\n" ,RCStruct.ulRC);
                DumpRC(&RCStruct);
        }
        return RCStruct.ulRC;
}




/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : WriteAttribute                                       */
/*                                                                          */
/*  Description      : This function is called by CmdUpdateMAttributes()    */
/*                     to update Item Attributes.                           */
/*                                                                          */
/*  Dependencies     : Global Variables : hItem, hSession                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibWriteAttr                   */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG                                               */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG WriteAttribute(USHORT pusMediaAttrID[])       */
/*                                                                          */
/*  Return values    :  None.                                               */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Call SimLibWriteAttr to update each unique attribute value      */
/*      2.  Return to caller with return code                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/
ULONG WriteAttribute(USHORT pusMediaAttrID[])
{
        ULONG                   ulRC;                 /* Return Code from Folder Manager API*/
    RCSTRUCT        RCStruct;                 /* RC data structure                  */
        INT                             i;                    /* Temp storage                       */
        FILE*                   stream;               /* File Handle                        */
        CHAR                    pszNewAttrList[6][30];/* New Attributes Arrary              */
        CHAR                    buffer[40];           /* Temp filename storage              */
        CHAR*                   token;                /* String parsing token               */
        CHAR            achLine[100];         /* storage for one row of text        */
    CHAR            seps[] = " =\n";       /* Delimiter                          */



        sprintf(buffer,"%s/NewAttrs.lst", achFrnrootPath); /* Getting file path    */
        stream = fopen(buffer, "r");                        /* Open file to read    */
        if (stream == NULL)                                 /* If file doesnot exist*/
        {
                printf("fopen Failed !\n ");
                printf("Can Not open file:  :::::::>>> %s\n",buffer);
                fflush(stdout);
                return(ERR_FILE_NOT_FOUND);                     /* Return as an error   */
        }
        else                  /* Rad new attributes from a file - NewAttrs.lst      */
        {
                i = 0;
                while( fgets(achLine, 100, stream) != NULL)
                {
                        token = strtok (achLine, seps);     /* parsing string               */
                        token = strtok ( NULL, seps);
                        strcpy (pszNewAttrList[i] , token); /* Copy new attributes to array */
                        i++;
                }
        }



        /*************************************************************************/
    /* Update MediaType                                                      */
    /*************************************************************************/
        ulRC = SimLibWriteAttr(
                        hSession,              /* Handle to a folder manager session.*/
                            hItem,                 /* Handle to a virtual item.          */
                                pusMediaAttrID[6],     /* Unique attribute identifier.       */
                                pszNewAttrList[0],     /* Pointer to value to be assigned to specified attribute.*/
                                (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous control block.*/
                                (PRCSTRUCT) &RCStruct);/* Pointer to return data structure.  */

        if (ulRC != SIM_RC_OK)
        {
                printf("WriteAttrbute error %lu\n", ulRC);
                DumpRC(&RCStruct);
                CloseAttribute();
                return ulRC;
        }

        /*************************************************************************/
    /* Update MediaDurSeconds                                                */
    /*************************************************************************/
        ulRC = SimLibWriteAttr(
                        hSession,              /* Handle to a folder manager session.*/
                            hItem,                 /* Handle to a virtual item.          */
                                pusMediaAttrID[10],    /* Unique attribute identifier.       */
                                pszNewAttrList[1],     /* Pointer to value to be assigned.   */
                                (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous cntl block.*/
                                (PRCSTRUCT) &RCStruct);/* Pointer to return data structure.  */

        if (ulRC != SIM_RC_OK)
        {
                printf("WriteAttrbute error %lu\n", ulRC);
                DumpRC(&RCStruct);
                CloseAttribute();
                return ulRC;
        }


        /*************************************************************************/
    /* Update MediaDurFrames                                                 */
    /*************************************************************************/
        ulRC = SimLibWriteAttr(
                        hSession,              /* Handle to a folder manager session.*/
                            hItem,                 /* Handle to a virtual item.          */
                                pusMediaAttrID[11],    /* Unique attribute identifier.       */
                                pszNewAttrList[2],     /* Pointer to value to be assigned.   */
                                (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous cntl block.*/
                                (PRCSTRUCT) &RCStruct);/* Pointer to return data structure.  */

        if (ulRC != SIM_RC_OK)
        {
                printf("WriteAttrbute error %lu\n", ulRC);
                DumpRC(&RCStruct);
                CloseAttribute();
                return ulRC;
        }

        /*************************************************************************/
    /* Update MediaFrame                                                     */
    /*************************************************************************/
        ulRC = SimLibWriteAttr(
                        hSession,              /* Handle to a folder manager session.*/
                            hItem,                 /* Handle to a virtual item.          */
                                pusMediaAttrID[12],    /* Unique attribute identifier.       */
                                pszNewAttrList[3],     /* Pointer to value to be assigned.   */
                                (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous cntl block.*/
                                (PRCSTRUCT) &RCStruct);/* Pointer to return data structure.  */

        if (ulRC != SIM_RC_OK)
        {
                printf("WriteAttrbute error %lu\n", ulRC);
                DumpRC(&RCStruct);
                CloseAttribute();
                return ulRC;
        }

        /*************************************************************************/
    /* Update MediaBitRate                                                   */
    /*************************************************************************/
        ulRC = SimLibWriteAttr(
                        hSession,              /* Handle to a folder manager session.*/
                            hItem,                 /* Handle to a virtual item.          */
                                pusMediaAttrID[13],    /* Unique attribute identifier.       */
                                pszNewAttrList[4],     /* Pointer to value to be assigned.   */
                                (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous cntl block.*/
                                (PRCSTRUCT) &RCStruct);/* Pointer to return data structure.  */

        if (ulRC != SIM_RC_OK)
        {
                printf("WriteAttrbute error %lu\n", ulRC);
                DumpRC(&RCStruct);
                CloseAttribute();
                return ulRC;
        }

        /*************************************************************************/
    /* Update MediaNumUsers                                                  */
    /*************************************************************************/
        ulRC = SimLibWriteAttr(
                        hSession,              /* Handle to a folder manager session.*/
                            hItem,                 /* Handle to a virtual item.          */
                                pusMediaAttrID[15],    /* Unique attribute identifier.       */
                                pszNewAttrList[5],     /* Pointer to value to be assigned.   */
                                (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous cntl block.*/
                                (PRCSTRUCT) &RCStruct);/* Pointer to return data structure.  */

        if (ulRC != SIM_RC_OK)
        {
                printf("WriteAttrbute error %lu\n", ulRC);
                DumpRC(&RCStruct);
                CloseAttribute();
                return ulRC;
        }

        return RCStruct.ulRC;
}










/*BEGINPROLOGUE**************************************************************/
/*                                                                          */
/*  Function         : CloseAttribute                                       */
/*                                                                          */
/*  Description      : This function is called by CmdUpdateMAttributes()    */
/*                     to close Item Attributes Session.                    */
/*                                                                          */
/*  Dependencies     : Global Variables : hItem, hSession                   */
/*                     Static External  :                                   */
/*                     Includes         :                                   */
/*                     Product Functions: SimLibCloseAttr                   */
/*                                                                          */
/*  Restrictions     :  None.                                               */
/*                                                                          */
/*  Function type    :  ULONG                                               */
/*                                                                          */
/*  Input Parameters :  None.                                               */
/*                                                                          */
/*  Output Parameters:  None.                                               */
/*                                                                          */
/*  Synopsis         :  ULONG CloseAttribute()                              */
/*                                                                          */
/*  Return values    :  None.                                               */
/*                                                                          */
/*  Process Flow     :                                                      */
/*                                                                          */
/*      1.  Call SimLibWriteAttr to close item atttribute session           */
/*      2.  Return to caller with return code                               */
/*                                                                          */
/*  Notes            :  None.                                               */
/*                                                                          */
/*ENDPROLOGUE****************************************************************/
ULONG CloseAttribute()
{
        ULONG                   ulRC;              /* Return Code from Folder Manager API        */
    RCSTRUCT        RCStruct;              /* RC data structure                          */

        ulRC = SimLibCloseAttr(
                                hSession,                          /* Handle to a folder manager session.        */
                                hItem,                             /* Handle to a virtual item.                  */
                                SIM_OPT_SAVE,          /* Save or discard virtual item attribute mods*/
                                (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous control block.     */
                                (PRCSTRUCT) &RCStruct);/* Pointer to return data structure.          */

        if (ulRC != SIM_RC_OK)             /* If return code is not zero                 */
        {
                printf("SimLibCloseItemAttr error %lu\n", ulRC);
                DumpRC(&RCStruct);
        }

        return RCStruct.ulRC;
}


//              if (ulRC == SIM_RC_OK)
//              {
//                      for (i=0; i < 17; i++)   /* display Media Attributes                            */
//                      {
//                              /*************************************************************************/
//                              /* Read Item Attribute for an unique attribute identifier                */
//                              /*************************************************************************/
//                              ulRC = ReadAttribute(i);
//                              if (ulRC != SIM_RC_OK)
//                              {
//                                      printf("SimLibReadAttr error %lu\n", ulRC);
//                                      return (INT)ulRC;
//                              }
//                      }
//              }
//              else
//              {
//                      printf("OpenItemAttr error %lu\n", ulRC);
//                      return ulRC;
//              }
//                              fscanf(stream, "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
//                               pszNewAttrList[0],     /*FRN$MediaItemID         */
//                               pszNewAttrList[1],     /*FRN$MediaRepType        */
//                               pszNewAttrList[2],     /*FRN$MediaPartNo         */
//                               pszNewAttrList[3],     /*FRN$MediaTimeStamp      */
//                               pszNewAttrList[4],     /*FRN$MediaState          */
//                               pszNewAttrList[5],     /*FRN$MediaInvalidCommands*/
//                               pszNewAttrList[6],     /*FRN$MediaType           */
//                               pszNewAttrList[7],     /*FRN$MediaResolution     */
//                               pszNewAttrList[8],     /*FRN$MediaStandard       */
//                               pszNewAttrList[9],     /*FRN$MediaFormat         */
//                               pszNewAttrList[10],    /*FRN$MediaDurSeconds     */
//                               pszNewAttrList[11],    /*FRN$MediaDurFrames      */
//                               pszNewAttrList[12],    /*FRN$MediaFrameRate      */
//                               pszNewAttrList[13],    /*FRN$MediarBitRate       */
//                               pszNewAttrList[14],    /*FRN$MediaCopyRate       */
//                               pszNewAttrList[15],    /*FRN$MediaNumUsers       */
//                               pszNewAttrList[16],    /*FRN$MediaAssetGroup     */
//                               pszNewAttrList[17],    /*FRN$MediaReserved1      */
//                               pszNewAttrList[18]);   /*FRN$MediaReserved2      */
//                                              fclose(stream);
//                      }
//
//
//                      for(i=1; i<18; i++)   /* Display new Attributes                */
//                      {
//                              printf("pszNewAttrList[%d]:  %s\n", i, pszNewAttrList[i]);
//                      }



                        /*************************************************************************/
                        /* Write Item Attribute for an unique attribute identifier               */
                        /*************************************************************************/
//                      for (i=0; i < 17; i++)
//                      {
//                              pszNewAttributeValue = pszNewAttrList[i];
//                              ulRC = SimLibWriteAttr(
//                                              hSession,              /* Handle to a folder manager session.*/
//                                                  hItem,                 /* Handle to a virtual item.          */
//                                                      pusMediaAttrID[i],     /* Unique attribute identifier.       */
//                                                      pszNewAttributeValue,  /* Pointer to value to be assigned to specified attribute.*/
//                                                      (PASYNCCTLSTRUCT)NULL, /* Pointer to asynchronous control block.*/
//                                                      (PRCSTRUCT) &RCStruct);/* Pointer to return data structure. */

ULONG MediaMigration(char * parm)
{

    FILE* FileHandle;                   /* File Handle                      */
        FILE* LogFileHandle;                /* Log File Handle                  */
        CHAR achBuffer[100];                /* Full Path of Migration file name */
        CHAR achMigFileName[50];            /* Migration Input file name        */
    INT  nLoopNumber=0;                 /* Number of file to migrate        */
        CHAR achFRN[] = "FRN$NULL";         /* delimiter                        */
        INT  rc;                            /* Return Code                      */
        CHAR achFileName[100];              /* Migration file name              */
        CHAR achIndexNum[10];               /* Char pointer of index number     */
        INT  i;                             /* Counter                          */
    PSZ  pszMigrationObject;            /* Char ponter of Migration Object  */


        strcpy (achMigFileName, parm);

        sprintf(achBuffer,"%s/%s", achFrnrootPath,achMigFileName);
        FileHandle = fopen(achBuffer,"r");  /* Open input migration file for read*/
        if (FileHandle == NULL)
        {
                 printf("fopen Failed !\n ");
                 printf("Can Not open file: %s \n",achBuffer);
                 fflush(stdout);
                 return ERR_FILE_NOT_FOUND;

        }

        sprintf(achBuffer,"%s/MigLog.txt", achFrnrootPath);
        LogFileHandle = fopen(achBuffer,"w"); /* Open log file for write         */
        if (LogFileHandle == NULL)
        {
                 printf("fopen Failed !\n ");
                 printf("Can Not open file: %s \n",achBuffer);
                 fflush(stdout);
                 return ERR_FILE_NOT_FOUND;
        }


        printf("Starting Media Migration....\n");

        fprintf(LogFileHandle,"INDEX#:     File Name            MEDIA_ITEM_ID        MediaState\n");
        fprintf(LogFileHandle,"-------     ----------------     ----------------     --------------------\n");


        while ( (rc =fscanf(FileHandle, "%s ", achFileName) ) != EOF )
        {

                pszMigrationObject = strstr(achFileName, achFRN); /* start String parsing*/

                if(pszMigrationObject == NULL)
                {

                    /*************************************************************************/
                        /*  Call LoadMediaObject function to migrate a new object                */
                        /*************************************************************************/

                        ulretcode = LoadMediaObject(achFileName);
                        nLoopNumber++;

                        if (ulretcode == SIM_RC_OK)
                        {
                                ReadItemName(ulTotalNumItemId);
                                printf("\n\n%4d     %16s  ===> %16s\n\n",nLoopNumber, achFileName,DocItemID);
                                fflush(stdout);

                                fprintf(LogFileHandle,"%7d   %s ----->  %s\n",nLoopNumber, achFileName, DocItemID);

                                sprintf(achIndexNum, "%d",(INT) ulTotalNumItemId);

                            /*************************************************************************/
                                /*  Call CmdMQuery function to check the media state of this object      */
                                /*************************************************************************/
                                ulretcode = CmdMQuery(achIndexNum);
                                i = 0;
                                while ((iObjectState != 2) && (i < 100)  )
                                {

#ifdef FRN_WINNT
                                        Sleep (5000);
#else
                                        sleep(5);
#endif
                                        ulretcode = CmdMQuery(achIndexNum);
                                        i++;
                                }

                            fprintf(LogFileHandle,"%7d\n", iObjectState);
/*                              if (iObjectState == 2)
                                {
                                        printf(" :::> OK\n");
                                        fflush(stdout);
                                }
                                else
                                {
                                        if (iObjectState == 3)
                                        {
                                                printf(" :::> FAILED\n");
                                                fflush(stdout);
                                        }
                                        else
                                        {
                                                printf(" :::> PROCESSING\n");
                                                fflush(stdout);
                                        }

                                }
*/
                        }
                        else
                        {
                                printf("\n\n%4d   %s ----->  %s\n\n",nLoopNumber, achFileName, "FAILED!!!");
                                fprintf(LogFileHandle,"%4d   %s ----->  %s\n",nLoopNumber, achFileName, "FAILED!!!");
                        }
                }
        }

        printf("End of Media Migration....\n");
        fclose(FileHandle);
        fclose(LogFileHandle);
    return RC_OK;
}
